"""
Django settings for djradicale project.

Generated by 'django-admin startproject' using Django 1.11.3.

For more information on this file, see
https://docs.djangoproject.com/en/1.11/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.11/ref/settings/
"""

import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.11/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'z9x^z)-d)&(fgm%ffq$k=slhg0+ki(m&)dwisy^-n0h7qhoi6^'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = False

ALLOWED_HOSTS = ['127.0.0.1']

AUTH_USER_MODEL = 'core.Mailbox'
AUTHENTICATION_BACKENDS = (
    'app.core.views.CustomBackend',
)

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',

    "app.core"
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'djradicale.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'djradicale.wsgi.application'


# Database
# https://docs.djangoproject.com/en/1.11/ref/settings/#databases
def get_mysql_password():
    import base64
    from configparser import ConfigParser

    cfg = ConfigParser()
    cfg.read('/usr/local/u-mail/config/custom.conf')
    if cfg.has_option('mysql', 'pass_security'):
        passwd = cfg.get('mysql', 'pass_security')
        cmd = ["/usr/local/u-mail/app/sbin/mypassword", "--decrypt", passwd]
        import os
        import subprocess
        child = subprocess.Popen(cmd, stdout=subprocess.PIPE, preexec_fn=os.setsid)
        out, err = child.communicate()
        passwd = out.strip()
    else:
        passwd = cfg.get('mysql', 'pass')
    if isinstance(passwd, bytes):
        passwd = passwd.decode()
    return passwd

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.mysql',
        'NAME': '{MYSQL_DBNAME}',                      # Or path to database file if using sqlite3.
        'USER': '{MYSQL_USER}',                      # Not used with sqlite3.
        'PASSWORD': get_mysql_password(),                  # Not used with sqlite3.
        'HOST': '{MYSQL_HOST}',                      # Set to empty string for localhost. Not used with sqlite3.
        'PORT': '{MYSQL_PORT}',                      # Set to empty string for default. Not used with sqlite3.
    },
}


# Password validation
# https://docs.djangoproject.com/en/1.11/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/1.11/topics/i18n/

LANGUAGE_CODE = 'en-us'

# TIME_ZONE = 'UTC'
TIME_ZONE = 'Asia/Shanghai'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.11/howto/static-files/

STATIC_URL = '/static/'

# ---------------------------
# 缓存配置 CACHES
CACHES = {
    "default": {
        "BACKEND": "django_redis.cache.RedisCache",
        #"LOCATION": "redis://:PASSWORD@127.0.0.1:6379", #if need password
        "LOCATION": "redis://redis:6379",
        "OPTIONS": {
            "CLIENT_CLASS": "django_redis.client.DefaultClient",
            "PARSER_CLASS": "redis.connection.HiredisParser",
        }
    }
}
USER_AGENTS_CACHE = 'default'



