# -*- coding: utf-8 -*-
"""
Django settings for WebVue project.

Generated by 'django-admin startproject' using Django 1.11.3.

For more information on this file, see
https://docs.djangoproject.com/en/1.11/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.11/ref/settings/
"""

import os
import sys

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
sys.path.insert(0, BASE_DIR)
sys.path.insert(0, os.path.join(BASE_DIR, 'extapp'))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.11/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = '{WEBVUE_JWT_SECRET_KEY}'
#SECRET_KEY = '^5e8do&qc=_oe2%7(ielne6lulac1u73j6$h+qp^dp34)6^9f5'

# SECURITY WARNING: don't run with debug turned on in production!
# DEBUG 千万不要设置为True。
# DEBUG = True
DEBUG = False
# 登录时，缓存收件箱10封邮件,5封未读邮件
LOGIN_TO_CACHE_MAIL = True

# True时，控制演示平台使用。 True 为演示平台，默认 False
WEBMAIL_TEST_PLATFORM = False
# API普通用户也可访问。 True 为普通用户不能访问API，默认 True
WEBMAIL_GENERAL_USER_API = True
# Comail登录页去掉阴影。 True 为隐藏Comail登录页阴影，默认 False
WEBMAIL_COREMAIL_LOGIN_RM_SHADOW = False
# 用户注册，控制部门展现。 True 为隐藏，默认 False
WEBMAIL_REGISTER_DEPT_SHOW = False
# 企业网盘上传者，权限为 上传权限，不能下载预览，只能发信。 True 为不能下载，默认 False
WEBMAIL_COMPANY_UPLOADER_SHOW = False
# 涉密系统，保存为草稿箱时写日志。 True 为写日志，默认 False
WEBMAIL_SECRETE_DRAFTS_SAVELOG = False
# 涉密系统，删除邮件（即移动邮件）/ 移动邮件写详细日志。True 为写日志，默认True
WEBMAIL_SECRETE_MAIL_SAVELOG = True
# 涉密系统隐藏企业网盘。True 为隐藏，默认 False
WEBMAIL_HIDE_COMPANY_NETDISK = False
# 文件中转站过期时间，单位：秒，默认8小时即（8*3600，3600为一小时），第一次保存到文件中转站时的默认过期时间，建议这个初始值。 最少可以设置为 3600
WEBMAIL_TRANSFER_FILE_EXPIRED = 8 * 3600
# 文件中转站续期时间，单位：秒， 默认7天，人为操作建议不要修改，最少可以设置为 24 * 3600
WEBMAIL_TRANSFER_FILE_DELAY = 7 * 24 * 3600
# 登录时验证UA，默认 True（即验证），(OA登录时，有可能360浏览器验证异常（极速和兼容模式），请设置为 False，其余情况建议使用默认值保证安全性。)
# 一律改为False 不进行验证了，有需求需要进行验证浏览器和IP的可以设置为True, 2019.11.21
WEBMAIL_CHECK_UA = False
# 不能上传的可执行文件后缀列表，注意只能维护小写。也可以清除所有的，即 WEBMAIL_EXCLUDE_EXTS = ( ) 表示不校验上传后缀。
WEBMAIL_EXCLUDE_EXTS = (
    'exe', 'scr', 'pif', 'vbs', 'cmd', 'com', 'bat', 'hta'
)
# 邮箱第一次登录时提示客户要创建邮箱搬家，默认：False （不开启提示）
WEBMAIL_IMAPMOVING = False
# 客户定制的一个第三方验证接口（填写客户的接口，对应方法oa_access_token）
WEBMAIL_ACCESS_TOKEN_URL = None
# 定制请求失败返回URL
WEBMAIL_OA_BACKURL = None
# 中恒工程设计院 登录逻辑， 使用则改为 True
WEBMAIL_ZHONGHENG_LOGIN = False


# 登录地点异常提醒（NAT架构的客户）。False为不提醒，默认True
WEBMAIL_LOGINIP_REMIND = True
# 自助查询隐藏。False 为隐藏，默认 True
WEBMAIL_CENTER_SHOW = True


# 草稿箱保存附件。False 为不保存，默认 True
WEBMAIL_SEND_SAVE_DRAFTS = True
# WEBMAIL_SEND_MAILTOATTACH：所有直接转附件；
# WEBMAIL_SEND_MAILTOATTACH_FLAG 大于多少M（WEBMAIL_SEND_MAILTOATTACH_SIZE）时转附件标记， WEBMAIL_SEND_MAILTOATTACH_SIZE 超过此大小才去
# 所有附件直接转在线附件。True 为转，默认 False
WEBMAIL_SEND_MAILTOATTACH = False
# 个人网盘大于50M是否转在线附件的标记。True 为转，默认 False
WEBMAIL_SEND_MAILTOATTACH_FLAG = False
# 大于50M的附件直接转在线附件， 单位MB
WEBMAIL_SEND_MAILTOATTACH_SIZE = 50

# 企业工号登陆页面显示开关 默认隐藏(False)
# WEBMAIL_EENUMBER_LOGIN = False
# 等保专用，webvue设置页面 个人资料隐藏False，正常情况下应该是开启True
# WEBMAIL_PROFILE_SHOW = True
# API接口调用日志记录 默认是记录(True), 不记录(False)
# WEBMAIL_API_LOG = True
# 芯动科技定制：邮件正文不允许插入新图片设置为True, 通用情况下默认为False
# CUSTOMER_INNOSILICON_DISABLE_UPLOAD_NEW_IMAGE = False
# web端登录欢迎语句,默认为"欢迎登录Webmail", 支持自定义
# WEBMAIL_WELCOME_LOGIN = u"欢迎登录Webmail"
# web端登配置禁用邮件删除操作, 默认是不禁止的（False）,禁用为（True）
# WEBMAIL_DISABLE_DELETE_BUTTON = False
# (INNOSILICON)回复邮件的时候隐藏之前的内容，True则隐藏，默认显示为False
# WEBMAIL_HIDE_FORWARD_CONTENTS = False
# 邮件编辑是自动保存草稿时间，默认5分钟
# WEBMAIL_DFAFT_AUTO_SAVE_MINUTE = 5

# CSRF Cookie(s) with timeout
CSRF_COOKIE_AGE = 60 * 60
# CSRF Cookie(s) with Secure flag set, 必须https才能设置
CSRF_COOKIE_SECURE = True
# CSRF Cookie(s) with HttpOnly flag set
CSRF_COOKIE_HTTPONLY = True

# 此项最好维护为客户webmail的域名
ALLOWED_HOSTS = ['*']
AUTH_USER_MODEL = 'core.Mailbox'
AUTHENTICATION_BACKENDS = (
    'app.core.views.CustomBackend',
)

# Application definition
INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'corsheaders',
    'django_filters',
    'rest_framework',
    'rest_framework_swagger',
    'app.core',
    'app.twofactor',
    'app.contact',
    'app.caldav',
    'app.carddav',
    'app.notebook',
    'app.netdisk',
    'app.center',
    'app.setting',
    'app.mail',
    'app.oa',
    'app.api',
    'app.wechat',
]

MIDDLEWARE = [
    'corsheaders.middleware.CorsMiddleware',
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.locale.LocaleMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'app.utils.middleware.xforwardedfor.XForwardedForMiddleware',
    'app.utils.middleware.xframe_options_exempt.XframeOptionsExemptMiddleware',
]
# 跨域问题，vuejs已经打进django工程，跨域设置为False
CORS_ORIGIN_ALLOW_ALL = False
# 跨域白名单，维护OA一键登录的时候最好设置CORS_ORIGIN_ALLOW_ALL = False， 此项填写客户的OA域名
# CORS_ORIGIN_WHITELIST = ( 'www.baidu.com', )
# 支持FRAME, OA嵌套使用，建议默认关闭
XFRAME_OPTIONS_EXEMPT = False
ROOT_URLCONF = 'WebVue.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': ['appfront/dist', 'appfront_mobile/dist_mobile', os.path.join(BASE_DIR, 'templates')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                "django.template.context_processors.i18n",
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'WebVue.wsgi.application'

# Database
# https://docs.djangoproject.com/en/1.11/ref/settings/#databases
def get_mysql_password():
    import base64
    from ConfigParser import ConfigParser
    from app.utils.xxtea import decrypt
    cfg = ConfigParser()
    cfg.read('/usr/local/u-mail/config/custom.conf')
    if cfg.has_option('mysql', 'pass_security'):
        passwd = cfg.get('mysql', 'pass_security')
        passwd = decrypt(base64.b32decode(passwd), "umailxxtea16byteslong")
    else:
        passwd = cfg.get('mysql', 'pass')
    return passwd

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.mysql',
        'NAME': '{MYSQL_DBNAME}',                      # Or path to database file if using sqlite3.
        'USER': '{MYSQL_USER}',                      # Not used with sqlite3.
        'PASSWORD': get_mysql_password(),                    # Not used with sqlite3.
        'HOST': '{MYSQL_HOST}',                      # Set to empty string for localhost. Not used with sqlite3.
        'PORT': '{MYSQL_PORT}',                      # Set to empty string for default. Not used with sqlite3.
    },
}

# ---------------------------
# 缓存配置 CACHES
CACHES = {
    "default": {
        "BACKEND": "django_redis.cache.RedisCache",
        #"LOCATION": "redis://:PASSWORD@127.0.0.1:6379", #if need password
        "LOCATION": "redis://redis:6379",
        "OPTIONS": {
            "CLIENT_CLASS": "django_redis.client.DefaultClient",
            "PARSER_CLASS": "redis.connection.HiredisParser",
        }
    }
}

USER_AGENTS_CACHE = 'default'

# Password validation
# https://docs.djangoproject.com/en/1.11/ref/settings/#auth-password-validators
AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/1.11/topics/i18n/
LANGUAGE_CODE = 'zh-Hans'

TIME_ZONE = 'UTC'
TIME_ZONE = 'Asia/Shanghai'

USE_I18N = True

USE_L10N = True

USE_TZ = False   #默认是Ture，时间是utc时间，由于我们要用本地时间，所用手动修改为false！！！！
# USE_TZ = True

from django.utils.translation import ugettext_lazy as _
LANGUAGE_COOKIE_NAME = "webvue_language"
LANGUAGES = (
    ('en-us', _(u"English")),
    ('zh-hans', _(u'简体中文')),
    # ('zh-hant', _(u'繁體中文')),
    ('zh-tw', _(u'繁體中文')),
    ('es', _(u'西班牙语')),
)
# 翻译文件所在目录，需要手工创建
LOCALE_PATHS = (
    os.path.join(BASE_DIR, 'locale'),
    os.path.join(BASE_DIR, "extapp/rest_framework_jwt/locale"),
)


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.11/howto/static-files/
STATIC_URL = '/staticvue/'
# Add for vuejs
STATICFILES_DIRS = [
    os.path.join(BASE_DIR, "appfront/dist/static"),
]

LOGIN_URL = 'rest_framework:login'
LOGIN_REDIRECT_URL = '/swagger/'


# ---------------------------
# restful
REST_FRAMEWORK = {
    ## Setting the pagination style  分页
    'DEFAULT_PAGINATION_CLASS': 'rest_framework.pagination.LimitOffsetPagination',
    'PAGE_SIZE': 10,

    # REST framework 包含许多内置的渲染器类，允许您使用各种 media type 返回响应。同时也支持自定义渲染器。
    'DEFAULT_RENDERER_CLASSES': (
        'rest_framework.renderers.JSONRenderer',
        # 'rest_framework.renderers.BrowsableAPIRenderer',
    ),

    # Use hyperlinked styles by default.
    # Only used if the `serializer_class` attribute is not set on a view.
    'DEFAULT_MODEL_SERIALIZER_CLASS':
        'rest_framework.serializers.HyperlinkedModelSerializer',

    # Use Django's standard `django.contrib.auth` permissions,
    # or allow read-only access for unauthenticated users.
    'DEFAULT_PERMISSION_CLASSES': [
        'rest_framework.permissions.IsAuthenticated',
        'rest_framework_jwt.permissions.SharePermission',
    ],

    'DEFAULT_AUTHENTICATION_CLASSES': (
        'rest_framework_jwt.authentication.JSONWebTokenAuthentication',
        # 'rest_framework.authentication.SessionAuthentication',
        # 'rest_framework.authentication.BasicAuthentication',
    ),
}

import datetime
JWT_AUTH = {
    'JWT_AUTH_HEADER_PREFIX': 'JWT',
    'JWT_EXPIRATION_DELTA': datetime.timedelta(hours=2),
}

# rest 缓存设置
REST_FRAMEWORK_EXTENSIONS = {
    'DEFAULT_USE_CACHE': 'default',
    'DEFAULT_CACHE_RESPONSE_TIMEOUT': 3600,
}


#IMAP 信息
IMAP_SERVER = 'postfix'
IMAP_PORT = 143
IMAP_SSL = False

# 本地发送邮件
SMTP_SERVER = "app"
SMTP_PORT = 10027
SMTP_RECEIVER = "eric@comingchina.com"

# 个人网盘路径
UMAIL_PERSIONAL_NETDISK_PATH = "/usr/local/u-mail/data/www/webmail/netdisk"
# 企业网盘路径
UMAIL_COMPANY_NETDISK_PATH = "/usr/local/u-mail/data/www/webmail/netdisk/public"
# 大文件上传 临时保存路径
UMAIL_NETDISK_MD5_PATH = "/usr/local/u-mail/data/www/webmail/netdisk/md5"
# 审核邮件保存路径
UMAIL_REVIEW_MAIL_PATH = "/usr/local/u-mail/data/app/data_review"
# 预览生成MD5文件使用, NGINX要部署的media提供出去
UMAIL_PREVIEW_OPENOFFICE_PATH = "/usr/local/u-mail/data/www/webmail/netdisk/media"
# /usr/bin/libreoffice6.1 预览office文档调用路径
LIBREOFFICE_BIN = "/usr/bin/libreoffice6.1"
# 单位：GB
UMAIL_COMPANY_NETDISK_CAPACITY = 50

# 日历同步
UMAIL_WEBCAL_ROOT_PATH = "/usr/local/u-mail/data/www/webmail/radicale"
# 日历同步配置文件
UMAIL_WEBCAL_CONFIG = "/usr/local/u-mail/config/webcal/radicale/radicale.conf"
# 日历同步目录
UMAIL_WEBCAL_COLLECTIONS = "/usr/local/u-mail/data/www/webmail/radicale/collections"

# 邮件缓存目录
UAMIL_CACHE_EMAIL_DIR = "/usr/local/u-mail/data/www/webmail/mailcache"

# 用户创建数量限制
# 日程
CREATE_LIMITED_CALENDAR = 5
# 个人网盘
CREATE_LIMITED_NETDISKFOLDER = 20
# 企业网盘
CREATE_LIMITED_NETDISK_COMPANYFOLDER = 200
# 签名
CREATE_LIMITED_SIGNATURE = 10
# 过滤器
CREATE_LIMITED_FILTER = 50
# 自动转发、自动回复
CREATE_LIMITED_FILTER_REFW = 50
# 模板信
CREATE_LIMITED_TEMPLATE = 20

# ---------------------------
# Celery settings
# redis://:PASSWORD@127.0.0.1:6379/0
CELERY_BROKER_URL = 'redis://localhost:6379/0'
CELERY_ACCEPT_CONTENT = ["json"]            # 指定任务接受的内容类型.
CELERY_ENABLE_UTC = True
CELERY_TIMEZONE = TIME_ZONE
CELERY_DEFAULT_QUEUE =  'linux-webvue-celery-default' #     默认队列
CELERYD_MAX_TASKS_PER_CHILD = 50    # 每个worker最多执行50个任务就会被销毁，可防止内存泄露  # 每个worker执行了多少任务就会死掉，默认是无限的
CELERYD_FORCE_EXECV = True  # 非常重要,有些情况下可以防止死锁
CELERYD_PREFETCH_MULTIPLIER = 1  # celery worker 每次去rabbitmq预取任务的数量
# ---------------------------

# 查询邮件发送状态以及召回邮件
SEARCH_MAIL_STATUS_HOST = 'app'
SEARCH_MAIL_STATUS_PORT = 10041
