/*
        从 2017-08 ， version=2.2.41 开始，
        底层接管一切sql语句的修改
*/

USE umail;

CREATE TABLE IF NOT EXISTS `co_user_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) DEFAULT NULL,
  `mailbox_id` int(11) DEFAULT NULL,
  `reg_id` int(11) DEFAULT NULL,
  `classify` varchar(64) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `action` varchar(35) DEFAULT NULL,
  `result` enum('1','-1') NOT NULL DEFAULT '1',
  `description` varchar(2000) DEFAULT '',
  `clientip` varchar(20) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `admin` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL DEFAULT '0',
  `username` varchar(40) DEFAULT NULL,
  `password` varchar(120) DEFAULT NULL COMMENT '密码',
  `usertype` enum('domainadmin','superadmin','systemadmin','deptadmin') NOT NULL DEFAULT 'domainadmin',
  `lastlogin` datetime DEFAULT NULL,
  `lastip` varchar(20) DEFAULT NULL,
  `disabled` enum('-1','1') NOT NULL DEFAULT '-1',
  `ip_limit` varchar(255) DEFAULT NULL,
  `is_active` tinyint(1) NOT NULL DEFAULT '1',
  `is_staff` tinyint(1) NOT NULL DEFAULT '1',
  `is_superuser` tinyint(1) NOT NULL DEFAULT '0' COMMENT '超级用户',
  `first_name` varchar(30) DEFAULT NULL,
  `last_name` varchar(30) DEFAULT NULL,
  `email` varchar(150) DEFAULT NULL,
  `date_joined` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `core_whitelist` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `operator` enum('user','sys') NOT NULL DEFAULT 'user',
  `type` varchar(20) NOT NULL DEFAULT 'recv' COMMENT '类型 recv:收件人白名单,send:发件人白名单,fix_send:指定外域发件白名单,fix_recv:指定外域收件',
  `version` tinyint(1) NOT NULL DEFAULT '1' COMMENT '将白名单区分为发件人和收件人后用于兼容旧数据的标记值',
  `domain_id` int(11) NOT NULL DEFAULT '0',
  `mailbox_id` int(11) NOT NULL DEFAULT '0',
  `dept_id` int(11) NOT NULL DEFAULT '0' COMMENT '部门ID',
  `email` varchar(60) DEFAULT NULL,
  `disabled` enum('-1','1') NOT NULL DEFAULT '-1',
  `add_time` int(11) NOT NULL DEFAULT '0' COMMENT '添加时间',
  `remark` text COMMENT '备注',
  PRIMARY KEY (`id`),
  KEY `email` (`email`),
  KEY `whitelist` (`domain_id`,`mailbox_id`,`operator`,`type`)
) ENGINE=MyISAM AUTO_INCREMENT=145792 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `core_domain` (
  `domain_id` int(11) NOT NULL AUTO_INCREMENT,
  `domain` varchar(50) DEFAULT NULL,
  `antivirus` enum('-1','1') NOT NULL,
  `antispam` enum('-1','1') NOT NULL,
  `sendlimit` enum('-1','1') NOT NULL DEFAULT '-1',
  `dkim` enum('-1','1') NOT NULL DEFAULT '-1',
  `recvsms` enum('-1','1') NOT NULL DEFAULT '-1',
  `sendsms` enum('-1','1') NOT NULL DEFAULT '-1',
  `userbwlist` enum('-1','1') NOT NULL DEFAULT '1',
  `popmail` enum('-1','1') NOT NULL DEFAULT '-1',
  `spaceclean` enum('-1','1') NOT NULL DEFAULT '-1',
  `impush` enum('-1','1') NOT NULL,
  `disabled` enum('-1','1') NOT NULL DEFAULT '-1',
  `share_domains` varchar(200) NOT NULL DEFAULT '0' COMMENT '允许企业邮箱查看其他域邮箱2,4,5',
  `share_title` varchar(200) NOT NULL DEFAULT '0' COMMENT '企业通讯录中域别名',
  `is_wx_host` int(2) NOT NULL DEFAULT '0' COMMENT '是否是微信api主域名',
  PRIMARY KEY (`domain_id`),
  KEY `domain` (`domain`)
) ENGINE=MyISAM AUTO_INCREMENT=18 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `core_domain_attr` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL DEFAULT '0',
  `type` enum('webmail','system') DEFAULT 'webmail',
  `item` varchar(35) DEFAULT NULL,
  `value` mediumtext,
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_unique` (`domain_id`,`type`,`item`)
) ENGINE=MyISAM AUTO_INCREMENT=49 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `co_department_member` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL DEFAULT '0',
  `dept_id` int(11) NOT NULL DEFAULT '0',
  `mailbox_id` int(11) NOT NULL DEFAULT '0',
  `position` varchar(35) DEFAULT NULL,
  `is_admin` enum('-1','1') NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_unique` (`dept_id`,`mailbox_id`),
  KEY `mailbox_id` (`mailbox_id`)
) ENGINE=MyISAM AUTO_INCREMENT=15441 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `core_trustip` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ip` varchar(48) DEFAULT NULL,
  `disabled` enum('-1','1') NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `ip` (`ip`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `core_alias` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL DEFAULT '0',
  `mailbox_id` int(11) NOT NULL DEFAULT '0',
  `type` varchar(20) NOT NULL DEFAULT 'mailbox',
  `source` varchar(200) DEFAULT NULL COMMENT '邮箱全名',
  `target` text,
  `disabled` enum('-1','1') NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `source` (`source`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- 2.2.43 2017-09-14
-- 兼容旧版升级过来的情况，webmail可能升级失败导致不会生成ext_review_mail表或者修改列属性失败
CREATE TABLE IF NOT EXISTS `ext_review_mail` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL DEFAULT '0',
  `mailbox_id` int(11) NOT NULL DEFAULT '0',
  `ident` varchar(25) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `sender` varchar(80) DEFAULT NULL,
  `recipient` text,
  `mailsize` int(11) NOT NULL DEFAULT '0',
  `subject` varchar(100) DEFAULT NULL,
  `attachment` tinyint(1) DEFAULT NULL,
  `savepath` text,
  `mailbody` longtext,
  `reason` text,
  `status` enum('wait','permit','reject','pass','stop') NOT NULL DEFAULT 'wait',
  `reviewer_id` varchar(80) NOT NULL DEFAULT '',
  `permit_address` varchar(250) NOT NULL DEFAULT '',
  `reject_address` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `mailbox_id` (`mailbox_id`),
  KEY `datetime` (`datetime`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;


-- 2.2.44 2017-10-13
-- webmail用到的登录验证表
CREATE TABLE IF NOT EXISTS `core_nonce` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `content` varchar(150) NOT NULL DEFAULT '0' COMMENT '验证登录字符串',
  `add_time` int(11) NOT NULL DEFAULT '0' COMMENT '新增时间',
  `ip` varchar(30) NOT NULL DEFAULT '0' COMMENT 'ip',
  `status` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '验证与否',
  PRIMARY KEY (`id`),
  UNIQUE KEY `index` (`content`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 2.2.44 end


-- 2.2.46 2017-11-06 start
-- 审核人表
CREATE TABLE IF NOT EXISTS `ext_review_new` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(250) DEFAULT '' COMMENT '管理员输入的审核人名称',
  `next_id` int(11) NOT NULL DEFAULT 0 COMMENT '下一级审核，ext_review_new的主键ID',
  `master_review`  int(11) NOT NULL COMMENT '主审的mailbox_id',
  `assist_review`    int(11) DEFAULT 0 COMMENT '副审的mailbox_id',
  `wait_next_time`    int(4) DEFAULT 0 COMMENT '自动把副审转换为审核人的等待时间，单位为分钟，=0为永不转移',
  PRIMARY KEY (`id`),
  KEY `next_id` (`next_id`)

) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- 2.2.46 2017-11-06
-- 审核规则表
CREATE TABLE IF NOT EXISTS `ext_review_new_rule` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `review_id` int(11) NOT NULL DEFAULT 0 COMMENT 'ext_review_new的主键ID',
  `name` varchar(250) DEFAULT '' COMMENT '管理员输入的审核名称',
  `workmode` varchar(20) NOT NULL DEFAULT 'outbound' COMMENT 'outbound,allsend',
  `cond_logic` varchar(20) DEFAULT "all" COMMENT '逻辑表达式 all , one',
  `pre_action` varchar(20) DEFAULT NULL COMMENT 'reject:满足条件就拒绝,permit:满足条件就通过,为空代表需人工审核',
  `target_dept` int(11) NOT NULL DEFAULT 0 COMMENT '需要审核的部门ID，默认为空',
  `sequence` int(6) NOT NULL DEFAULT 999 COMMENT '数值越小优先级越高,数值相等时主键越小优先级越高',
  `disabled` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '1禁用-1启用',

  PRIMARY KEY (`id`),
  KEY `review_id` (`review_id`)

) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;


-- 2.2.46 2017-11-06
-- 审核规则条件表
CREATE TABLE IF NOT EXISTS `ext_review_new_condition` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) NOT NULL DEFAULT 0 COMMENT '这个条件的父亲ID，逻辑关系由parent_id指向的那一行决定',
  `rule_id` int(11) NOT NULL DEFAULT 0 COMMENT 'ext_review_new_rule的主键ID',
  `option` varchar(50) DEFAULT NULL COMMENT '条件',
  /*
      1）主题  ： subject
      2）邮件内容：content
      3）收件人 ： recipient
      4) 发件人： sender
      5) 邮件大小: mail_size
      6) 邮件时间: date
      7) 审核所有附件： has_attach
      8）附件名 ： attachment
      9）附件大小： attach_size
  */
  `action` varchar(20) DEFAULT NULL COMMENT '匹配动作',
  /*
      1）包含  ： "contains"
      2）不包含 ： "not_contains"
      3）等于  ： "=="
      4）大于等于  ： ">="
      5）小于等于  ： "<="
  */
  `value` varchar(250) DEFAULT NULL COMMENT '用户输入的字符串值',

  PRIMARY KEY (`id`),
  KEY `rule_id` (`rule_id`)

) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;


-- 2.2.46 2017-11-06
-- 审核进度表
CREATE TABLE IF NOT EXISTS `ext_review_new_process` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `review_id` int(11) NOT NULL DEFAULT 0 COMMENT 'ext_review_new的主键ID',
  `mail_id` int(11) NOT NULL COMMENT 'ext_review_mail的主键ID',
  `reviewer_id` int(11) NOT NULL DEFAULT 0  COMMENT '审核人的mailbox_id',
  `type` varchar(20) NOT NULL DEFAULT 'master'  COMMENT 'master,assist',
  `status` varchar(20) NOT NULL DEFAULT 'wait' COMMENT '取值为 wait、permit、reject,用于记录审核操作结果',
  `reason` text COMMENT '修改status的原因',
  `start_time` datetime DEFAULT NULL COMMENT '开始时间',
  `last_update` datetime DEFAULT NULL COMMENT '上次保存的时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY (`reviewer_id`,`mail_id`)
)  ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- 2.2.46 2017-11-06 end

-- 2.2.46 2017-11-06
-- 前台登录页面模板

drop PROCEDURE if EXISTS add_table_base;
DELIMITER $$
create procedure add_table_base()
BEGIN
        IF NOT EXISTS (SELECT * FROM information_schema.COLUMNS WHERE TABLE_SCHEMA='umail' AND table_name='core_domain_login_temp')
        THEN
            CREATE TABLE `core_domain_login_temp` (
              `temp_id` int(11) NOT NULL AUTO_INCREMENT COMMENT '前台登录页面模板主键',
              `code` varchar(80) NOT NULL COMMENT '唯一标识字母码',
              `temp_name` varchar(200) NOT NULL COMMENT '模板名称',
              `add_time` int(11) DEFAULT NULL COMMENT '添加时间',
              `update_time` int(11) DEFAULT NULL COMMENT '更新时间',
              `folder` varchar(200) NOT NULL COMMENT '模板存放文件夹',
              `src` varchar(100) NOT NULL COMMENT '图片地址',
              `type` tinyint(2) NOT NULL DEFAULT '0' COMMENT '0前端登录模板1后台登录模板',
              PRIMARY KEY (`temp_id`),
              UNIQUE KEY `index` (`code`),
              UNIQUE KEY `lina_index` (`folder`,`type`)
            ) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

            INSERT INTO `core_domain_login_temp`(`temp_id`,`code`,`temp_name`,`add_time`,`update_time`,`folder`,`src`,`type`)
            VALUES (1,'manual','手动域名登录页面',3,33,'login_domain','/webmail/admin/style/img/login_temp2.png',0),
                     (2,'adlogin','广告风格登录页面',2,2,'login_ad','/webmail/admin/style/img/login_temp3.png',0),
                     (3,'gao','大气管理员风格页面',2,33,'login_gao','/webmail/admin/style/img/login_temp4.png',0),
                     (4,'test','轮播图风格登录页面',3,344,'login_cao','/webmail/admin/style/img/login_temp5.png',0);
        END IF;
END $$
DELIMITER ;
call add_table_base();
drop PROCEDURE if EXISTS add_table_base;

-- 2.2.46 2017-11-06 end


-- 2.2.47 2017-11-21 兼容创建某些旧版本可能因为错误没有创建成功的表
CREATE TABLE IF NOT EXISTS `ext_sequester_mail` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ident` varchar(25) DEFAULT NULL,
  `datetime` datetime DEFAULT NULL,
  `sender` varchar(80) DEFAULT NULL,
  `recipient` text,
  `mailsize` int(11) NOT NULL DEFAULT '0',
  `subject` varchar(300) DEFAULT NULL COMMENT '隔离邮件主题,长于300字符的就截断',
  `attachment` tinyint(1) DEFAULT NULL,
  `savepath` text,
  `status` enum('wait','permit','whitelist','whitelist2','reject','stop','pass') NOT NULL DEFAULT 'wait' COMMENT '隔离状态',
  `reason` varchar(50) NOT NULL,
  `detail` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `ext_list` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL DEFAULT '0',
  `listname` varchar(35) DEFAULT NULL,
  `listtype` enum('general','dept','sys') NOT NULL DEFAULT 'general',
  `dept_id` int(11) NOT NULL DEFAULT '0',
  `permission` enum('public','private') NOT NULL DEFAULT 'public' COMMENT '权限',
  `address` varchar(200) DEFAULT NULL COMMENT '邮箱全名',
  `showorder` int(11) NOT NULL DEFAULT '0',
  `description` text,
  `disabled` enum('-1','1') NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `address` (`address`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `ext_list_member` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL DEFAULT '0',
  `list_id` int(11) NOT NULL DEFAULT '0',
  `address` varchar(80) DEFAULT NULL,
  `permit` enum('-1','0','1') NOT NULL DEFAULT '-1',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT 'win版本导入过来的昵称',
  `update_time` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`id`),
  KEY `list_id` (`list_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `ext_reply` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL DEFAULT '0',
  `domain_id` int(11) NOT NULL DEFAULT '0',
  `address` varchar(200) DEFAULT NULL COMMENT '邮箱全名',
  `body` text,
  `work_mode` enum('full','limit') NOT NULL DEFAULT 'full' COMMENT 'app 2.2.47后废弃',
  `work_start` datetime DEFAULT NULL COMMENT 'app 2.2.47后废弃',
  `work_end` datetime DEFAULT NULL COMMENT 'app 2.2.47后废弃',
  `disabled` enum('1','-1') NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `mailbox_id` (`mailbox_id`),
  KEY `address` (`address`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `ext_forward` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL DEFAULT '0',
  `domain_id` int(11) NOT NULL DEFAULT '0',
  `mailbox` varchar(200) DEFAULT NULL COMMENT '邮箱全名',
  `forward` text,
  `visible` enum('-1','1') NOT NULL DEFAULT '1',
  `keep_mail` enum('-1','1') NOT NULL DEFAULT '1',
  `disabled` enum('-1','1') NOT NULL DEFAULT '-1',
  `local` enum('-1','1') NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `mailbox` (`mailbox`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `wm_netdisk_files` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL DEFAULT '0',
  `mailbox_id` int(11) NOT NULL DEFAULT '0',
  `folder_id` int(11) NOT NULL DEFAULT '0',
  `file_name` varchar(150) DEFAULT NULL,
  `file_path` varchar(100) DEFAULT NULL,
  `file_type` varchar(50) DEFAULT NULL,
  `file_suffix` varchar(10) DEFAULT NULL,
  `file_size` int(11) NOT NULL DEFAULT '0',
  `created` datetime DEFAULT NULL,
  `sharetime_end` int(11) NOT NULL DEFAULT '0' COMMENT '文件共享结束时间',
  `online_attach_time` int(11) NOT NULL DEFAULT '0' COMMENT '在线附件转存时间，后期可根据这个字段自动清理网盘',
  `share_code` varchar(100) DEFAULT NULL COMMENT '下载的验证码',
  PRIMARY KEY (`id`),
  KEY `mailbox_id` (`mailbox_id`),
  KEY `folder_id` (`folder_id`)
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `ext_translate_header` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) DEFAULT NULL,
  `type` enum('-1','1') NOT NULL DEFAULT '-1' COMMENT '-1外发1接收',
  `rule` varchar(250) DEFAULT NULL COMMENT '需要替换的规则',
  `trans_value` varchar(250) DEFAULT NULL COMMENT '客户输入的替换目标',
  `disabled` enum('-1','1') NOT NULL DEFAULT '-1' COMMENT '-1启用1禁用',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=15 DEFAULT CHARSET=utf8;

-- 2.2.47 2017-11-21 end

-- 2.2.47 2017-11-22
-- 通用的条件表
CREATE TABLE IF NOT EXISTS `ext_common_checkrule` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL DEFAULT 0 COMMENT 'core_mailbox的主键ID',
  `type` varchar(50) DEFAULT NULL COMMENT 'forward,reply',
  `logic` varchar(50) DEFAULT "all" COMMENT '逻辑表达式 all , one',
  `disabled` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '1禁用-1启用',

  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- 2.2.47 2017-11-22
-- 通用的条件表2
CREATE TABLE IF NOT EXISTS `ext_checkrule_condition` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) NOT NULL DEFAULT 0 COMMENT '这个条件的父亲ID，逻辑关系由parent_id指向的那一行决定',
  `logic` varchar(50) NOT NULL DEFAULT "one" COMMENT '逻辑表达式 all , one',
  `rule_id` int(11) NOT NULL DEFAULT 0 COMMENT 'ext_common_checkrule的主键ID',
  `option` varchar(50) DEFAULT NULL COMMENT '条件',
  /*
      1）主题  ： subject
      2）收件人 ： recipient
      3) 发件人： sender
      4) 邮件大小 : mail_size
      5) 执行时间 ： exec_date
      6) 所有邮件 : all_mail
      7）抄送人 ： copy_addr
  */
  `action` varchar(20) DEFAULT NULL COMMENT '匹配动作',
  /*
      1）包含  ： "contains"
      2）不包含 ： "not_contains"
      3）等于  ： "=="
      4）大于等于  ： ">="
      5）小于等于  ： "<="
      6）区间  ： "between"

      action=between时， value = {"start":xx,"end":yy}
      if option == "exec_date":
          action 必然为 between
          value有两种格式的值
          value = {
            "type"  : "date",
            "start"  : 格式为yy-mm-dd xx:xx:xx的开始日期,
            "end"   : 格式为yy-mm-dd xx:xx:xx的结束日期,
          }
          value = {
            "type"  : "week",
            "day_start" : 1--7 代表周一到周日的值,
            "day_end" : 1--7 代表周一到周日的值,
            "start"  : 格式为 时:分 的时间,
            "end"   : 格式为 时:分 的时间,
          }
      action=其它值， value = { "value":xxx }
  */
  `value` varchar(500) DEFAULT NULL COMMENT '用户输入的json值。如: {"value":xxx,"start":xx,"end":yy}',
  `disabled` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '1禁用-1启用',

  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`)

  #FOREIGN KEY REFERENCES ext_common_checkrule(`id`)

) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
-- 2.2.47 2017-11-22 end

-- 2.2.47 2017-11-30
-- 服务器升级log
CREATE TABLE IF NOT EXISTS `core_upgrade_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) DEFAULT NULL COMMENT '名称，如app,webmail,operation',
  `version` varchar(50) DEFAULT NULL COMMENT '当前版本',
  `prev` varchar(50) DEFAULT NULL COMMENT '前一次升级的版本',
  `update_time` datetime DEFAULT NULL COMMENT '系统升级的时间',

  PRIMARY KEY (`id`),
  KEY `name` (`name`),
  UNIQUE KEY (`name`,`version`)

) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
-- 2.2.47 2017-11-30 end


-- 2.2.48 2017-12-18
-- -----------新的内容过滤器规则表
CREATE TABLE IF NOT EXISTS `ext_cfilter_rule_new` (
  `id` int(11) NOT NULL AUTO_INCREMENT,

  `mailbox_id` int(11) NOT NULL DEFAULT 0 COMMENT 'mailbox_id=0时为系统过滤，有值时为用户过滤',
  `name` varchar(150) DEFAULT NULL COMMENT '管理员输入的规则备注，可不填',
  `type` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '1:接收，-1:外发',
  `logic` varchar(50) NOT NULL DEFAULT "all" COMMENT '逻辑表达式 all , one',
  /*
  all  : 满足所有条件，   one  ： 满足一条即可
  */

  `sequence` int(6) NOT NULL DEFAULT 999 COMMENT '规则的优先级',
  `disabled` tinyint(1) NOT NULL DEFAULT '-1',

  PRIMARY KEY (`id`),
  KEY `mailbox_id` (`mailbox_id`)

) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;


-- -----------条件组表
CREATE TABLE IF NOT EXISTS `ext_cfilter_new_cond` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) NOT NULL DEFAULT 0 COMMENT '这个条件的父亲ID，逻辑关系由parent_id指向的那一行决定',
  `rule_id` int(11) NOT NULL DEFAULT 0 COMMENT '所属节点，ext_cfilter_rule_new的主键',
  /*

  */
  `logic` varchar(50) NOT NULL DEFAULT "all" COMMENT '逻辑表达式 all , one',
  /*
  all : 并且   one ： 或
  */
  `option` varchar(50) NOT NULL DEFAULT "extra" COMMENT '隐藏字段，用于用户复杂自定义设置条件',
  /*
    header
    extra
    自定义的时候才添加header
    其他所有类型都是 extra
  */
  `suboption` varchar(50) DEFAULT NULL COMMENT '需要匹配的字段',
    /*
      all_mail         所有邮件
      has_attach     有附件
      sender    发信人
      cc         抄送人
      recipient   收信人
      sender_dept 发信人部门
      cc_dept      抄送人部门
      rcpt_dept    收信人部门
      subject     主题
      body        邮件体
      mail_size    邮件大小，单位为M
    */

  `action` varchar(50) DEFAULT NULL COMMENT '匹配动作 in, not_in, not_contains, contains, ==, >=, <=',
    /*
      1）包含  ： "contains"
      2）不包含 ： "not_contains"
      3）等于  ： "=="
      4）大于等于  ： ">="
      5）小于等于  ： "<="
      6) 属于 : "in"
      7）不属于 ： "not_in"

      可以为 not_in , in 的  option
          sender_dept ， cc_dept ， rcpt_dept
      可以为 >= , <= 的 option
          mail_size
      特殊设置的 option:
          all_mail , has_attach 的option只能为 ==

      除了 sender_dept , cc_dept , rcpt_dept , all_mail , has_attach 这几个 option，
      其他所有option都可以有的：
          contains, not_contains, ==
    */

  `value`  varchar(500) DEFAULT NULL COMMENT '条件的值',
  /*
    option in (all_mail, has_attach) , value 不填或 == 1
    option in ( sender_dept , cc_dept , rcpt_dept)  value 为 co_department的主键
    其他值为任意字符串
  */
  PRIMARY KEY (`id`)

) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;


-- -----------新的内容过滤器动作表
CREATE TABLE IF NOT EXISTS `ext_cfilter_new_action` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `rule_id` int(11) NOT NULL DEFAULT 0 COMMENT 'ext_cfilter_new_rule主键',
  `action` varchar(50) DEFAULT NULL COMMENT '要对邮件进行的操作',
  /*
    break   中断执行规则
    jump_to 跳过后面N个规则
    flag    设置旗帜
    label   设置标签
    delete  删除邮件
    sequester  隔离邮件
    move_to 移动邮件至文件夹
    copy_to 复制邮件至文件夹
    forward 转发
    delete_header 删除邮件头
    append_header 追加头部
    append_body 追加邮件内容
    mail 发送邮件
  */
  `value` text COMMENT '根据action_type的不同，值的格式也不同，有值时为json格式',
  /*
    break     value = null
    jump_to   value = { "value":int }
    delete    value = null
    sequester   value =  null
    move_to   value = { 'value':前端存入的文件夹名称 }
    copy_to   value = { 'value':前端存入的文件夹名称 }
    forward   value = { 'value':前端存入的邮箱，以','分隔 }
    delete_header     value = { 'field':邮件头字段 }
    append_header     value = { 'field':邮件头字段, 'value':前端存入的值 }
    append_body     value = { 'value':前端存入的值 }
  */
  `sequence` int(6) NOT NULL DEFAULT 999 COMMENT '动作的优先级',

  PRIMARY KEY (`id`),
  KEY `rule_id` (`rule_id`)

) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- 2.2.48 2017-12-18 end


-- 2.2.48 2017-12-26 替换出站的发件人
CREATE TABLE IF NOT EXISTS `ext_smtp_transfer` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL COMMENT '设置的邮箱的mailbox_id',
  `server` varchar(200) DEFAULT NULL  COMMENT '目标服务器的域名或IP地址',
  `account` varchar(200) DEFAULT NULL  COMMENT '发件帐号',
  `password` varchar(200) DEFAULT NULL  COMMENT '帐号密码',
  `ssl` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '1使用 -1不使用，使用时连接端口465,不使用时25',
  `auth` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '1需要验证 -1不需要验证',
  `disabled` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '1禁用-1启用',

  PRIMARY KEY (`id`),
  KEY (`mailbox_id`)
)  ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
-- 2.2.48 end


-- 2.2.48 2017-12-28 补充创建一些基础表
CREATE TABLE IF NOT EXISTS `core_auth_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) DEFAULT NULL,
  `user` varchar(100) DEFAULT NULL,
  `type` varchar(10) DEFAULT NULL,
  `client_ip` varchar(20) DEFAULT NULL,
  `is_login` tinyint(1) DEFAULT '0',
  `time` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- 2.2.48 2017-12-28 补充创建一些基础表 end

-- 2.2.49 2018-01-04 补充创建一些基础表
CREATE TABLE IF NOT EXISTS `core_mailbox` (
  `mailbox_id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL DEFAULT '0',
  `domain` varchar(50) DEFAULT NULL,
  `name` varchar(80) NOT NULL DEFAULT '',
  `mailbox` varchar(200) NOT NULL COMMENT '邮箱全名',
  `password` varchar(40) DEFAULT NULL,
  `savepath` varchar(100) DEFAULT NULL,
  `quota_mailbox` int(11) NOT NULL DEFAULT '0',
  `quota_netdisk` int(11) NOT NULL DEFAULT '0',
  `limit_send` enum('-1','1','2','3','4') NOT NULL DEFAULT '-1',
  `limit_recv` enum('-1','1','2','3','4') NOT NULL DEFAULT '-1',
  `limit_pop` enum('-1','1') NOT NULL DEFAULT '-1' COMMENT '>=2.2.58后废弃，与组权限冲突',
  `limit_imap` enum('-1','1') NOT NULL DEFAULT '-1' COMMENT '>=2.2.58后废弃，与组权限冲突',
  `limit_login` char(2) NOT NULL DEFAULT '-1' COMMENT '1:只允许客户端登录,-1:不限制',
  `recvsms` enum('-1','1','0') NOT NULL DEFAULT '1',
  `sys_mailbox` enum('-1','1') NOT NULL DEFAULT '-1',
  `disabled` enum('-1','1') NOT NULL DEFAULT '-1',
  `ip_limit` varchar(255) DEFAULT NULL,
  `change_pwd` char(2) NOT NULL DEFAULT '-1' COMMENT '修改密码，登录时判断1为修改，-1为不修改2修改并禁用帐号',
  `enable_share` tinyint(4) NOT NULL DEFAULT '-1',
  `first_change_pwd` int(2) DEFAULT '-1' COMMENT '首次登录强制修改密码, >=2.2.58后废弃',
  `pwd_days` int(10) NOT NULL DEFAULT '0' COMMENT '密码有效天数',
  `pwd_days_time` int(11) NOT NULL DEFAULT '1506514987' COMMENT '密码有效开始时间',
  PRIMARY KEY (`mailbox_id`),
  UNIQUE KEY `mailbox_unique` (`mailbox`),
  KEY `mailbox` (`mailbox`),
  KEY `disabled` (`disabled`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `core_mail_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `main_id` varchar(30) DEFAULT NULL,
  `domain_id` int(11) DEFAULT NULL,
  `mailbox_id` int(11) DEFAULT NULL,
  `type` enum('in','out','in_reject','out_reject') NOT NULL DEFAULT 'out',
  `send_mail` varchar(100) DEFAULT NULL,
  `rcv_mail` varchar(100) DEFAULT NULL,
  `subject` varchar(200) DEFAULT NULL,
  `size` bigint(11) DEFAULT NULL,
  `attachment` varchar(3000) DEFAULT NULL COMMENT '附件名称',
  `attachment_size` bigint(11) DEFAULT NULL,
  `result` enum('1','-1') NOT NULL DEFAULT '1',
  `description` text,
  `send_time` datetime DEFAULT NULL,
  `recv_time` datetime DEFAULT NULL COMMENT '服务器接收的时间',
  `senderip` varchar(20) DEFAULT NULL,
  `status` varchar(20) DEFAULT NULL,
  `rcv_server` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `domain_id` (`domain_id`,`mailbox_id`),
  KEY `type` (`type`),
  KEY `size` (`size`),
  KEY `attachment_size` (`attachment_size`),
  KEY `send_time` (`send_time`),
  KEY `main_id` (`main_id`),
  KEY `recv_time` (`recv_time`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `core_bcc` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL DEFAULT '0',
  `target` varchar(80) DEFAULT NULL,
  `target_dept` int(11) NOT NULL DEFAULT '0' COMMENT '监控部门',
  `forward` varchar(80) DEFAULT NULL,
  `type` enum('recipient','sender') NOT NULL DEFAULT 'recipient',
  `target_type` varchar(20) NOT NULL DEFAULT '*' COMMENT '*：内发/外发,in：内发,out：外发',
  `monit_move` varchar(10) NOT NULL DEFAULT '-1' COMMENT '1：监控邮箱搬家,-1:不监控',
  `disabled` enum('-1','1') NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `target` (`target`)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;
-- 2.2.49 2018-01-04 补充创建一些基础表 end

-- 2.2.49 2018-01-05 帐号数据迁移任务表
CREATE TABLE IF NOT EXISTS `ext_account_transfer` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL DEFAULT 0 COMMENT '被迁移的邮箱ID',
  `mailbox` varchar(200) NOT NULL COMMENT '被迁移的邮箱',
  `mailbox_to` varchar(200) NOT NULL COMMENT '目标邮箱',
  `mode` varchar(200) DEFAULT NULL COMMENT '迁移模式，格式为 { maildata:1,netdisk:1,contact:1 }',
  `succ_del` tinyint(2) NOT NULL DEFAULT '1' COMMENT '1：成功后删邮箱,-1:成功后不删邮箱',
  `status`  varchar(20) NOT NULL DEFAULT 'wait',
   /*'status 值的意义：
    wait:初始化完成，等待同步数据
    deleting：开始删除帐号，这个阶段会等待底层执行完毕
    deleted:删完帐号
    finished:已结束
   */
   `last_update` datetime DEFAULT NULL COMMENT '数据表上次更新的时间',
   `desc_msg` text DEFAULT NULL COMMENT '描述，任意阶段，当底层觉得有必要显示提示时，会往这里填充数据',
   `disabled` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '1停止，-1开始',

  PRIMARY KEY (`id`),
  KEY (`mailbox_id`),
  UNIQUE KEY (`mailbox_id`,`mailbox_to`)

)  ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
-- 2.2.49 2018-01-05 帐号数据迁移任务表 end

-- 2.2.49 2018-01-15 新运维平台新增表
CREATE TABLE IF NOT EXISTS `core_url_remark` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `url` varchar(200) NOT NULL COMMENT 'url地址',
  `remark` text DEFAULT NULL COMMENT '备注',

  PRIMARY KEY (`id`),
  UNIQUE KEY (`url`)

)  ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
-- 2.2.49 2018-01-15 新运维平台新增表 end

-- 2.2.50 2018-01-04 补充创建一些基础表 start
CREATE TABLE IF NOT EXISTS `ext_popmail` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL DEFAULT '0',
  `mailbox_id` int(11) NOT NULL DEFAULT '0',
  `src_mailbox` varchar(50) DEFAULT '',
  `src_server` varchar(50) DEFAULT NULL,
  `src_password` varchar(50) DEFAULT NULL,
  `src_keepmail` enum('1','-1') NOT NULL DEFAULT '1',
  `dst_mailbox` varchar(50) DEFAULT NULL,
  `dst_folder` varchar(50) DEFAULT NULL,
  `status` varchar(20) NOT NULL DEFAULT 'wait' COMMENT 'wait:空闲,moving:迁移中,done:迁移完毕',
  `desc_msg` text DEFAULT NULL COMMENT '描述，任意阶段，当底层觉得有必要显示提示时，会往这里填充数据',
  `lasttime` datetime DEFAULT NULL,
  `disabled` enum('-1','1') NOT NULL DEFAULT '-1',

  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
-- 2.2.50 2018-01-04 补充创建一些基础表 end

-- 2.2.50 2018-01-24 imap迁移数据表
CREATE TABLE IF NOT EXISTS `ext_imapmail` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL DEFAULT '0' COMMENT '本地帐号ID',
  `mailbox` varchar(150) DEFAULT NULL COMMENT '本地帐号',

  `src_mailbox` varchar(150) DEFAULT '' COMMENT '远程帐号',
  `src_server` varchar(100) DEFAULT NULL COMMENT '远程服务器，可以是IP也可以是域名',
  `ssl` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '是否ssl访问',
  `src_password` varchar(50) DEFAULT NULL,
  `src_folder` varchar(100) DEFAULT NULL COMMENT '迁移的目录 all:所有, INBOX:收件箱',

  `set_from` varchar(20) NOT NULL DEFAULT 'file' COMMENT 'admin:管理界面输入,file:文件导入,user:用户输入',
  `status` varchar(20) NOT NULL DEFAULT 'wait' COMMENT 'wait:空闲,moving:迁移中,done:迁移完毕',
  `last_update` datetime DEFAULT NULL COMMENT '最后一次更新时间',
  `desc_msg` text DEFAULT NULL COMMENT '描述，任意阶段，当底层觉得有必要显示提示时，会往这里填充数据',
  `disabled` tinyint(2) NOT NULL DEFAULT '-1',

  PRIMARY KEY (`id`),
  KEY (`mailbox`),
  UNIQUE KEY (`mailbox_id`,`src_mailbox`)

) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
-- 2.2.50 2018-01-24 imap迁移数据表 end

-- 2.2.51 2018-02-05 补充一些基本表
CREATE TABLE IF NOT EXISTS `core_mail_list` (
  `add_time` int(11) NOT NULL DEFAULT '0' COMMENT '记录添加日期',
  `pwd` varchar(40) NOT NULL DEFAULT '' COMMENT '加密密码',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT '邮件主键',
  `msgno` int(11) NOT NULL DEFAULT '0' COMMENT '邮件no',
  `folder` varchar(200) NOT NULL DEFAULT 'inbox' COMMENT '存储的文件夹',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT '发送状态0失败，1成功',
  `subject` varchar(500) NOT NULL COMMENT '发送邮件主题',
  `toaddress` varchar(1000) NOT NULL COMMENT '发送者',
  `fromaddress` varchar(1000) NOT NULL COMMENT '接收者',
  `maildate` int(11) NOT NULL COMMENT '发件日期',
  `pwd_status` tinyint(4) NOT NULL DEFAULT '0' COMMENT '0没有加密1加密未查看2加密已查看',
  `body` text NOT NULL COMMENT '邮件内容'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- 2.2.51 2018-02-05 补充一些基本表 end

-- 2.2.52 2018-03-05 进站邮件中转
CREATE TABLE IF NOT EXISTS `ext_post_transfer` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL COMMENT '设置的邮箱的mailbox_id',
  `mailbox` varchar(200) DEFAULT NULL COMMENT '用户邮箱',

  `type`  varchar(20) NOT NULL DEFAULT 'in' COMMENT 'int:内发,out:外发,all:所有',
  `server` varchar(200) DEFAULT NULL  COMMENT '目标服务器的域名或IP地址',
  `account` varchar(200) DEFAULT NULL  COMMENT '发件帐号',
  `recipient` varchar(200) DEFAULT NULL  COMMENT '收件帐号',
  `password` varchar(200) DEFAULT NULL  COMMENT '帐号密码',
  `ssl` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '1使用 -1不使用，使用时连接端口465,不使用时25',
  `auth` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '1需要验证 -1不需要验证',
  `fail_report` varchar(200) DEFAULT NULL COMMENT '投递失败后的通知人',
  `disabled` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '1禁用-1启用',

  PRIMARY KEY (`id`),
  KEY (`mailbox_id`),
  KEY (`mailbox`)
)  ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
-- 2.2.52 2018-03-05 进站邮件中转 end

-- 2.2.53 2018-03-13 log统计的缓存表
CREATE TABLE IF NOT EXISTS `ext_log_report` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL DEFAULT '0' COMMENT '域名ID',
  `mailbox_id` int(11) NOT NULL DEFAULT '0' COMMENT 'mailbox_id',
  `type`  varchar(50) NOT NULL COMMENT '标记这行数据的类型，如 report:统计报表,active:活跃邮箱',
  `key`   varchar(100) DEFAULT NULL COMMENT '这行数据的key',
  `data`  varchar(2000) DEFAULT NULL COMMENT 'json内容',

  `last_update` datetime DEFAULT NULL COMMENT '最后一次更新时间',

  PRIMARY KEY (`id`),
  KEY (`domain_id`),
  KEY (`mailbox_id`),
  UNIQUE KEY (`domain_id`,`mailbox_id`,`type`,`key`)
)  ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

--
CREATE TABLE IF NOT EXISTS `ext_log_active` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL DEFAULT '0' COMMENT '域名ID',
  `mailbox_id` int(11) NOT NULL DEFAULT '0' COMMENT 'mailbox_id',
  `name` varchar(200) DEFAULT NULL COMMENT '用户名',
  `key`   varchar(100) DEFAULT NULL COMMENT '这行数据的key，格式一般为 2018-01-01 00:00:00',
  `total_count`  int(11) NOT NULL DEFAULT '0' COMMENT 'key这天的总发件数量',
  `total_flow`  int(11) NOT NULL DEFAULT '0' COMMENT 'key这天的总发件流量',
  `in_count`  int(11) NOT NULL DEFAULT '0' COMMENT '入站数量',
  `in_flow`  int(11) NOT NULL DEFAULT '0' COMMENT '入站流量',
  `out_count`  int(11) NOT NULL DEFAULT '0' COMMENT '出站数量',
  `out_flow`  int(11) NOT NULL DEFAULT '0' COMMENT '出站流量',
  `spam_count`  int(11) NOT NULL DEFAULT '0' COMMENT '垃圾邮件数量',
  `spam_flow`  int(11) NOT NULL DEFAULT '0' COMMENT '垃圾邮件流量',
  `success_count`  int(11) NOT NULL DEFAULT '0' COMMENT '成功数量',
  `success_flow`  int(11) NOT NULL DEFAULT '0' COMMENT '成功流量',
  `failure_count`  int(11) NOT NULL DEFAULT '0' COMMENT '失败数量',
  `failure_flow`  int(11) NOT NULL DEFAULT '0' COMMENT '失败流量',
  `spam_ratio`  varchar(10) DEFAULT '0' COMMENT '垃圾率',
  `success_ratio`  varchar(10) DEFAULT '0' COMMENT '成功率',
  `last_update` datetime DEFAULT NULL COMMENT '最后一次更新时间',
  PRIMARY KEY (`id`),
  KEY (`domain_id`),
  KEY (`mailbox_id`),
  KEY (`name`),
  KEY (`total_count`,`total_flow`),
  KEY (`spam_ratio`,`success_ratio`),
  UNIQUE KEY (`domain_id`,`mailbox_id`,`key`)
)  ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
-- -- 2.2.53 2018-03-13 log统计的缓存表 end

-- 2.2.55 2018-04-16 ldap同步表
CREATE TABLE IF NOT EXISTS `ext_ldap_list` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `priority`  int(11) NOT NULL DEFAULT '999' COMMENT '优先级,数值越小优先级越高',
  `domain_id` int(11) NOT NULL DEFAULT '0' COMMENT '域名ID',
  `type`   varchar(20) NOT NULL DEFAULT 'ad' COMMENT 'ldap, ad',
  `server_domain` varchar(100) DEFAULT NULL COMMENT '目标服务器的域名',
  `server`   varchar(100) DEFAULT NULL COMMENT '服务器地址',
  `port`  int(11) NOT NULL DEFAULT '389' COMMENT '端口',
  `account`   varchar(200) DEFAULT NULL COMMENT '帐号',
  `password`   varchar(100) DEFAULT NULL COMMENT '密码',
  `ou`   varchar(500) DEFAULT NULL COMMENT '部门',

  `create_acct` varchar(50) NOT NULL COMMENT '创建帐号使用的字段, username, email',
  `create_dept` varchar(50) NOT NULL COMMENT '创建部门使用的字段, department, ou',

  `remark` text DEFAULT NULL COMMENT '备注',
  `disabled` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '1禁用-1启用',

  PRIMARY KEY (`id`)
)  ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- 2.2.55 2018-04-16 ldap同步表 end

-- 2.2.55 2018-05-15 fail2ban
CREATE TABLE IF NOT EXISTS `ext_fail2ban` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT NULL COMMENT '管理员输入的名称',
  `proto` varchar(50) NOT NULL DEFAULT 'all' COMMENT 'smtp,smtps,imap,imaps,pop3,pop3s,all',
  `internal` int(8) NOT NULL DEFAULT '0' COMMENT '统计间隔',
  `block_fail` int(6) NOT NULL DEFAULT '0' COMMENT '验证失败次数',
  `block_unexists` int(6) NOT NULL DEFAULT '0' COMMENT '验证不存在帐号次数',
  `block_minute` int(11) NOT NULL DEFAULT '0' COMMENT '禁用时间，单位为分钟',
  `update_time` datetime DEFAULT NULL COMMENT '最后一次更新时间',
  `remark` text DEFAULT NULL COMMENT '备注',
  `disabled` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '1禁用-1启用',

  PRIMARY KEY (`id`),
  KEY (`proto`),
  KEY (`block_minute`),
  KEY (`block_fail`),
  KEY (`block_unexists`)
)  ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `ext_fail2ban_trust` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT NULL COMMENT '管理员输入的名称',
  `ip` varchar(50) DEFAULT NULL COMMENT '信任IP',
  `disabled` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '1禁用-1启用',

  PRIMARY KEY (`id`),
  KEY (`ip`)
)  ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `ext_fail2ban_block` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT NULL COMMENT '管理员输入的名称',
  `ip` varchar(50) DEFAULT NULL COMMENT '被封禁的IP',
  `proto` varchar(50) NOT NULL DEFAULT 'all' COMMENT 'smtp,smtps,imap,imaps,pop3,pop3s,all',

  `expire_time` int(11) NOT NULL DEFAULT '0' COMMENT '过期时间',
  `update_time` datetime DEFAULT NULL COMMENT '最后一次更新时间',
  `disabled` tinyint(2) NOT NULL DEFAULT '-1' COMMENT '1禁用-1启用',

  PRIMARY KEY (`id`),
  UNIQUE KEY (`ip`,`proto`),
  KEY (`expire_time`)
)  ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
-- 2.2.55 2018-05-15 fail2ban

-- 2.2.55 2018-05-18 升级记录表
CREATE TABLE IF NOT EXISTS `core_upgrade_list` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `company` varchar(250) NOT NULL DEFAULT 'Unknown' COMMENT '公司名称',
  `domain` varchar(100) NOT NULL COMMENT 'domain',
  `app` varchar(50) DEFAULT NULL COMMENT 'app',
  `prev_app` varchar(50) DEFAULT NULL COMMENT 'app前一个版本',
  `webmail` varchar(50) DEFAULT NULL COMMENT 'webmail',
  `prev_webmail` varchar(50) DEFAULT NULL COMMENT 'webmail前一个版本',
  `operation` varchar(50) DEFAULT NULL COMMENT 'operation',
  `prev_operation` varchar(50) DEFAULT NULL COMMENT 'operation前一个版本',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',

  PRIMARY KEY (`id`),
  UNIQUE KEY (`domain`)
)  ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
-- 2.2.55 2018-05-18


-- 删除 >=2.2.54 后废弃的一些表
DROP TABLE IF EXISTS core_mail_log_history;
DROP TABLE IF EXISTS core_auth_log_history;
DROP TABLE IF EXISTS ext_cfilter_new_log;
-- 删除 >=2.2.54 后废弃的一些表 完毕


-- 2.2.56 2018-07-25 超级管理后台拓展
-- 2.2.61 版本时删除了大多数字段，将字段转移到 core_group_setting
-- 组权限管理
-- 2.2.56 2018-07-25 超级管理后台拓展
-- 2.2.61 版本时删除了大多数字段，将字段转移到 core_group_setting
-- 组权限管理
CREATE TABLE IF NOT EXISTS `core_group` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL,
  `name` varchar(100) NOT NULL,
  `description` longtext,
  `version` varchar(2) DEFAULT '2' COMMENT '这个字段后面的所有字段都废弃了，改为core_group_setting',
  PRIMARY KEY (`id`),
  UNIQUE KEY `domain_id` (`domain_id`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 2.2.61 2018-12-06 新版本组权限配置表
CREATE TABLE IF NOT EXISTS `core_group_setting` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `group_id` int(11) NOT NULL,
  `type` varchar(20) NOT NULL,
  `value` text,
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_unique` (`group_id`,`type`),
  FOREIGN KEY(`group_id`) REFERENCES core_group(`id`) ON DELETE CASCADE
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- 2.2.61 2018-12-06 新版本组权限配置表 end

-- 组权限成员
CREATE TABLE IF NOT EXISTS `core_group_member` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `group_id` int(11) NOT NULL,
  `mailbox_id` int(11) NOT NULL,
  `remark` text,
  `created` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `mailbox_id` (`mailbox_id`),
  UNIQUE KEY `group_id` (`group_id`,`mailbox_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 权限
CREATE TABLE IF NOT EXISTS `auth_user_user_permissions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `permission_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`),
  KEY `permission_id` (`permission_id`),
  KEY `user_id_2` (`user_id`),
  KEY `permission_id_2` (`permission_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `auth_user_groups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `group_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`),
  KEY `group_id` (`group_id`),
  KEY `user_id_2` (`user_id`),
  KEY `group_id_2` (`group_id`),
  KEY `user_id_3` (`user_id`),
  KEY `group_id_3` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `perm_mypermission` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) DEFAULT NULL COMMENT '父ID',
  `permission_id` int(11) DEFAULT NULL COMMENT '权限ID',
  `name` varchar(50) NOT NULL COMMENT '权限名称',
  `is_nav` tinyint(1) NOT NULL DEFAULT '1' COMMENT '是否为导航',
  `nav_name` varchar(50) NOT NULL COMMENT '导航名称',
  `url` varchar(150) DEFAULT NULL COMMENT '目录url',
  `is_default` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否为默认权限',
  `order_id` int(11) NOT NULL DEFAULT '1' COMMENT '导航顺序',
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`),
  KEY `parent_id` (`parent_id`),
  KEY `permission_id` (`permission_id`),
  KEY `url` (`url`),
  KEY `url_2` (`url`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `co_user_domain` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `domain_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `user_id` (`user_id`,`domain_id`)
) ENGINE=MyISAM AUTO_INCREMENT=71 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `co_user_department` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `department_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `user_id` (`user_id`,`department_id`)
) ENGINE=MyISAM AUTO_INCREMENT=28 DEFAULT CHARSET=utf8;
-- 2.2.56 2018-07-25 超级管理后台拓展 end

-- insert into auth_permission(name,content_type_id,codename) (select nav_name,id,name from perm_mypermission) on duplicate key update name=values(name);


-- 2.2.56 2018-08-24 超级管理后台拓展
-- 管理员日志表
CREATE TABLE IF NOT EXISTS `auditlog_logentry` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `object_pk` varchar(255) CHARACTER SET utf8 NOT NULL,
  `object_id` bigint(20) DEFAULT NULL,
  `object_repr` longtext CHARACTER SET utf8 NOT NULL,
  `action` smallint(5) unsigned NOT NULL,
  `changes` longtext CHARACTER SET utf8 NOT NULL,
  `timestamp` datetime NOT NULL,
  `actor_id` int(11) DEFAULT NULL,
  `content_type_id` int(11) NOT NULL,
  `remote_addr` varchar(39) CHARACTER SET utf8 DEFAULT NULL,
  `additional_data` longtext CHARACTER SET utf8,
  `domain_id` int(11) NOT NULL,
  `extend_type` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `is_extend` tinyint(1) NOT NULL,
  `extend_content` longtext CHARACTER SET utf8,
  PRIMARY KEY (`id`),
  KEY `auditlog_logentry_object_id_09c2eee8` (`object_id`),
  KEY `auditlog_logentry_actor_id_959271d2` (`actor_id`),
  KEY `auditlog_logentry_content_type_id_75830218` (`content_type_id`),
  KEY `auditlog_logentry_object_pk_6e3219c0` (`object_pk`),
  KEY `auditlog_logentry_domain_id_bca4a182` (`domain_id`),
  KEY `auditlog_logentry_extend_type_cd983b52` (`extend_type`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `auditlog_auditlogcontentype` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `content_type_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `content_type_id` (`content_type_id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- 管理员日志表
-- 2.2.56 2018-08-24 超级管理后台拓展 end

-- 2.2.59 2018-10-24 安全设置-密码规则
CREATE TABLE IF NOT EXISTS `ext_password_weak` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `password` varchar(32) DEFAULT NULL COMMENT '弱密码',
  PRIMARY KEY (`id`),
  UNIQUE KEY `password` (`password`)
)  ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
-- 2.2.59 2018-10-24 安全设置-密码规则 end

-- 2.2.60 2018-10-25 新邮件提醒
CREATE TABLE IF NOT EXISTS `core_new_mail` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL,
  `uid` int(11) NOT NULL DEFAULT 0 COMMENT 'imap的uid',
  `inbox` varchar(200) NOT NULL DEFAULT 'INBOX' COMMENT '收信目录',
  `created` int(11) NOT NULL DEFAULT 0 COMMENT '时间戳',
  PRIMARY KEY (`id`),
  KEY `mailbox_id` (`mailbox_id`),
  KEY `created` (`created`),
  KEY `mail` (`inbox`,`uid`)
)  ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
-- 2.2.60 2018-10-25 新邮件提醒 end

-- 2.2.61 2018-11-15 新版webmail新增表
CREATE TABLE IF NOT EXISTS `core_user_find` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL,
  `code` varchar(4) DEFAULT NULL,
  `count` int(11) NOT NULL DEFAULT '0',
  `carbled` varchar(100) DEFAULT NULL COMMENT '唯一乱码',
  `new_carbled` varchar(100) DEFAULT NULL COMMENT '唯一乱码，密码验证',
  `expired` int(11) NOT NULL DEFAULT '0',
  `expired_long` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `mailbox_id` (`mailbox_id`),
  KEY `new_carbled` (`new_carbled`),
  KEY `carbled` (`carbled`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='密码召回记录';

CREATE TABLE IF NOT EXISTS `wm_company_folder` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL DEFAULT '0',
  `parent_id` int(11) NOT NULL DEFAULT '-1',
  `name` varchar(150) DEFAULT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `mailbox_id` int(11) DEFAULT NULL COMMENT '文件夹创建者',
  PRIMARY KEY (`id`),
  UNIQUE KEY `domain_id` (`domain_id`,`parent_id`,`name`),
  KEY `mailbox_id` (`mailbox_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `wm_company_file` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL DEFAULT '0',
  `folder_id` int(11) NOT NULL DEFAULT '-1',
  `file_name` varchar(150) DEFAULT NULL,
  `file_path` varchar(100) DEFAULT NULL,
  `file_type` varchar(200) DEFAULT NULL,
  `file_suffix` varchar(10) DEFAULT NULL,
  `file_size` int(11) NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT NOW(),
  `mailbox_id` int(11) DEFAULT NULL COMMENT '文件上传者',
  PRIMARY KEY (`id`),
  KEY `domain_id` (`domain_id`,`folder_id`,`file_name`),
  KEY `mailbox_id` (`mailbox_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `wm_company_folder_permisson` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL,
  `type` int(11) NOT NULL DEFAULT '2' COMMENT '权限类型:1部门，2邮箱',
  `folder_id` int(11) NOT NULL DEFAULT '0' COMMENT '文件夹ID',
  `object_id` int(11) NOT NULL DEFAULT '0' COMMENT '邮箱ID或者部门ID',
  `object_name` varchar(300) DEFAULT NULL,
  `perm` tinyint(2) NOT NULL DEFAULT '3' COMMENT '权限',
  PRIMARY KEY (`id`),
  UNIQUE KEY `domain_id` (`domain_id`,`type`,`folder_id`,`object_id`),
  KEY `domain_id_2` (`domain_id`,`type`,`object_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='企业网盘权限表';

CREATE TABLE IF NOT EXISTS `core_mail_delete_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL,
  `mailbox_id` int(11) NOT NULL,
  `created` datetime NOT NULL COMMENT '删除时间',
  `subject` varchar(200) DEFAULT NULL COMMENT '主题',
  `send_mail` varchar(100) DEFAULT NULL COMMENT '发信人',
  `type` varchar(6) NOT NULL DEFAULT 'web' COMMENT '删除类型',
  `message_id` varchar(200) DEFAULT NULL COMMENT 'Message-Id',
  `folder` varchar(100) DEFAULT NULL COMMENT '删除位置',
  PRIMARY KEY (`id`),
  KEY `domain_id` (`domain_id`,`mailbox_id`),
  KEY `message_id` (`message_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- 2.2.61 2018-11-15 新版webmail新增表 end

-- --------------------------------------------------
-- 2.2.62 2018-11-15 新版本webmail表
CREATE TABLE IF NOT EXISTS `core_mail_attach` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) DEFAULT NULL,
  `type` varchar(50) DEFAULT NULL,
  `filepath` varchar(100) DEFAULT NULL,
  `filename` varchar(100) DEFAULT NULL,
  `content_type` varchar(100) DEFAULT NULL,
  `size` int(11) NOT NULL DEFAULT '0',
  `uid` int(11) DEFAULT NULL,
  `folder` varchar(50) DEFAULT NULL,
  `created` datetime NOT NULL,
  `mfrom` varchar(100) DEFAULT NULL,
  `subject` varchar(200) DEFAULT NULL,
  `expire_end` int(11) NOT NULL DEFAULT '0' COMMENT '附件过期时间',
  PRIMARY KEY (`id`),
  KEY `expire_end` (`expire_end`),
  KEY `mailbox_id` (`mailbox_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='附件管理';

CREATE TABLE IF NOT EXISTS `core_mail_burn` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mail_to` varchar(165) NOT NULL,
  `message_id` varchar(165) NOT NULL,
  `burn_limit` int(11) NOT NULL DEFAULT '1',
  `burn_count` int(11) NOT NULL DEFAULT '0',
  `burn_day` int(11) NOT NULL DEFAULT '0',
  `created` datetime NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `mail_to` (`mail_to`,`message_id`),
  KEY `burn_day` (`burn_day`)
) ENGINE=MyISAM AUTO_INCREMENT=26 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `core_mail_schedule` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL,
  `message_id` varchar(250) NOT NULL,
  `schedule_day` int(11) NOT NULL DEFAULT '0',
  `created` datetime NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `mailbox_id` (`mailbox_id`,`message_id`),
  KEY `schedule_day` (`schedule_day`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

 CREATE TABLE IF NOT EXISTS `core_mail_recall` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL,
  `message_id` varchar(200) NOT NULL,
  `recipient` text,
  `burn_day` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `mailbox_id` (`mailbox_id`,`message_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `core_mail_template` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL,
  `caption` varchar(50) NOT NULL COMMENT '模板标题',
  `content` longtext NOT NULL COMMENT '模板内容',
  `created` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `mailbox_id` (`mailbox_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='模板信';
-- 2.2.61 2018-11-15 新版本webmail表 end

-- 2.2.60 2018-10-29 邮件发送log
CREATE TABLE IF NOT EXISTS `core_send_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL DEFAULT '0' COMMENT '发信人的ID',
  `message_id` varchar(200) DEFAULT NULL COMMENT '邮件的message_id',
  `recipients` text COMMENT '收信人列表，json格式 [xxx,]',
  `subject` varchar(200) DEFAULT NULL COMMENT '邮件主题',
  `send_time` datetime DEFAULT NULL COMMENT '邮件头的发信时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `mailbox_idx` (`mailbox_id`,`message_id`)
) ENGINE=InnoDB AUTO_INCREMENT=411426 DEFAULT CHARSET=utf8;
-- 2.2.60 2018-10-29 邮件发送log end

-- 2.2.61 2018-12-10 替换 core_send_status
CREATE TABLE IF NOT EXISTS `core_send_status` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL DEFAULT 0 COMMENT 'core_mailbox的主键ID',
  `message_id` varchar(200) NOT NULL COMMENT '邮件头的message-id',
  `recipient` varchar(200) NOT NULL COMMENT '邮箱地址',
  `src_recipient` varchar(200) DEFAULT NULL COMMENT '原始邮箱地址',
  `name` varchar(100) DEFAULT NULL COMMENT '收件人姓名',
  `main_id` varchar(100) DEFAULT NULL COMMENT 'task_id的main_id,底层填充用于查日志',
  `folder` varchar(200) DEFAULT NULL COMMENT '收件人存储的文件夹',
  `filename` varchar(200) DEFAULT NULL COMMENT '存储时的文件名',
  `status` varchar(20) DEFAULT 'undeliver' COMMENT 'undeliver:未投递,deliver:投递成功,未读,readed:已读',
  `recall_status` varchar(20) DEFAULT 'stay' COMMENT 'stay:未召回,recall_succ:成功召回,recall_fail:召回失败',
  `deliver_time` datetime DEFAULT NULL COMMENT '邮件投递成功的时间',
  `recall_time` datetime DEFAULT NULL COMMENT '邮件召回的时间',
  `code` varchar(20) DEFAULT NULL COMMENT '投递或召回错误码',
  `subject` text DEFAULT NULL COMMENT '标题',

  PRIMARY KEY (`id`),
  UNIQUE KEY `mailbox_idx` (`mailbox_id`,`message_id`,`recipient`)

) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
-- 2.2.61 2018-12-10 替换 core_send_status end

-- 2.2.61 2018-12-20 页面说明
CREATE TABLE IF NOT EXISTS `core_webmail_remark` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `lang` varchar(30) NOT NULL COMMENT '语言',
  `page` varchar(30) NOT NULL COMMENT '页面类型',
  `name` varchar(100) DEFAULT NULL COMMENT '页面名称',
  `value` longtext COMMENT '页面文档说明',
  PRIMARY KEY (`id`),
  UNIQUE KEY `lang` (`lang`,`page`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- 2.2.61 2018-12-20 页面说明 end

-- 2.3.1 2019-01-02 双因素认证
CREATE TABLE IF NOT EXISTS `twofactor_otp` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `otp_type` varchar(20) NOT NULL DEFAULT 'TOTP',
  `secret_key` varchar(100) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `twofactor_phone` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `phone` varchar(128) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- 2.3.1 2019-01-02 双因素认证 end

-- 2.3.1 2019-01-11 发送统计， 先删除老版本的表
drop PROCEDURE if EXISTS drop_table;
DELIMITER $$
create procedure drop_table()
BEGIN
        IF EXISTS (SELECT * FROM information_schema.COLUMNS WHERE TABLE_SCHEMA='umail' AND table_name='core_send_statistics' AND COLUMN_NAME = 'web_count')
        THEN
        drop table core_send_statistics;
        END IF;
        IF EXISTS (SELECT * FROM information_schema.COLUMNS WHERE TABLE_SCHEMA='umail' AND table_name='core_send_statistics' AND COLUMN_NAME = 'sequester_count')
        THEN
        drop table core_send_statistics;
        END IF;
END $$
DELIMITER ;
call drop_table();
drop PROCEDURE if EXISTS drop_table;

CREATE TABLE IF NOT EXISTS `core_send_statistics` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain_id` int(11) NOT NULL DEFAULT 0 COMMENT 'core_domain的主键ID',
  `mailbox_id` int(11) NOT NULL DEFAULT 0 COMMENT 'core_mailbox的主键ID',
  `day` varchar(30) NOT NULL COMMENT '日期',
  `web_send` int(11) NOT NULL DEFAULT 0 COMMENT 'Web发信数量',
  `client_send` int(11) NOT NULL DEFAULT 0 COMMENT '客户端发信数量',
  `rcpt_count` int(11) NOT NULL DEFAULT 0 COMMENT '累计收信人次',
  `rcpt_in` int(11) NOT NULL DEFAULT 0 COMMENT '内网收信人数量',
  `rcpt_out` int(11) NOT NULL DEFAULT 0 COMMENT '外网收信人数量',
  `succ_in` int(11) NOT NULL DEFAULT 0 COMMENT '成功内发收信人数量',
  `succ_out` int(11) NOT NULL DEFAULT 0 COMMENT '成功外发收信人数量',
  `recv_in` int(11) NOT NULL DEFAULT 0 COMMENT '接收本地邮件数量',
  `recv_out` int(11) NOT NULL DEFAULT 0 COMMENT '接收外域邮件数量',
  `recv_succ_in` int(11) NOT NULL DEFAULT 0 COMMENT '成功接收内网邮件数量',
  `recv_succ_out` int(11) NOT NULL DEFAULT 0 COMMENT '成功接收外网邮件数量',
  `send_spam` int(11) NOT NULL DEFAULT 0 COMMENT '发送垃圾邮件数量',
  `send_virus` int(11) NOT NULL DEFAULT 0 COMMENT '发送病毒邮件数量',
  `recv_spam` int(11) NOT NULL DEFAULT 0 COMMENT '接收垃圾邮件数量',
  `recv_virus` int(11) NOT NULL DEFAULT 0 COMMENT '接收病毒邮件数量',
  `send_sequester` int(11) NOT NULL DEFAULT 0 COMMENT '发送的邮件被隔离数量',
  `recv_sequester` int(11) NOT NULL DEFAULT 0 COMMENT '接收的邮件被隔离数量',
  `status` tinyint(2) NOT NULL DEFAULT 0 COMMENT '0:正常状态,1:警报状态,2:禁止状态',
  `status_time` int(11) NOT NULL DEFAULT 0 COMMENT '状态开始时间',

  PRIMARY KEY (`id`),
  KEY (`domain_id`),
  KEY (`mailbox_id`),
  KEY (`day`),
  KEY (`status`),
  UNIQUE KEY `flag` (`mailbox_id`, `day`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
--  2019-01-11 发送统计 end

-- 2019-02-21 国密SM9相关数据表
-- 加密信息表，每一个邮件文件都指向一个唯一的uuid
-- CREATE TABLE IF NOT EXISTS `gmssl_encrypt` (
--   `id` int(11) NOT NULL AUTO_INCREMENT,
--   `mailbox_id` int(11) NOT NULL DEFAULT 0 COMMENT 'core_mailbox的主键ID',
--   `identity` varchar(200) NOT NULL COMMENT '邮箱地址,通过冗余数据来摆脱对core_mailbox的依赖',
--   `uuid` varchar(64) NOT NULL COMMENT '分配给邮件的唯一ID',
--   `idx` int(11) NOT NULL DEFAULT 0 COMMENT '标记idx,多个文件时会递增',
--   `name` varchar(32) NOT NULL DEFAULT '' COMMENT '子文件夹名称',
--   `prikey` text NOT NULL COMMENT 'master根据这个id生成的私钥的base64格式',
--   `update_time` datetime DEFAULT NULL COMMENT '更新时间',
--
--   PRIMARY KEY (`id`),
--   UNIQUE KEY (`mailbox_id`, `uuid`, `idx`)
-- ) ENGINE=MyISAM DEFAULT CHARSET=utf8;
--
-- CREATE TABLE IF NOT EXISTS `gmssl_decrypt` (
--   `id` int(11) NOT NULL AUTO_INCREMENT,
--   `mailbox_id` int(11) NOT NULL DEFAULT 0 COMMENT 'core_mailbox的主键ID',
--   `uuid` varchar(64) NOT NULL COMMENT '分配给邮件的唯一ID',
--   `decrypt` int(11) DEFAULT NULL COMMENT '解密时间戳',
--
--   PRIMARY KEY (`id`),
--   UNIQUE KEY (`mailbox_id`, `uuid`)
-- ) ENGINE=MyISAM DEFAULT CHARSET=utf8;
--
-- -- CREATE TABLE IF NOT EXISTS `gmssl_auth` (
--   `id` int(11) NOT NULL AUTO_INCREMENT,
--   `mailbox_id` int(11) NOT NULL DEFAULT 0 COMMENT 'core_mailbox的主键ID',
--   `key` varchar(200) NOT NULL COMMENT '密码标志符,可以为邮箱地址也可以为域名如: aa@bb.com, @cc.net',
--   `password` varchar(64) DEFAULT NULL COMMENT '密码的MD5值',
--
--   PRIMARY KEY (`id`),
--   UNIQUE KEY (`mailbox_id`, `key`)
-- ) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 2019-02-21 国密SM9相关数据表 end


-- 2019-02-28 新版本日历同步表
-- --------------------------------------------------
DROP TABLE IF EXISTS `core_calender`;
DROP TABLE IF EXISTS `core_calender_share`;
DROP TABLE IF EXISTS `core_calender_event`;
DROP TABLE IF EXISTS `core_calender_eventer`;
DROP TABLE IF EXISTS `schedule_calender`;
DROP TABLE IF EXISTS `schedule_share`;
DROP TABLE IF EXISTS `schedule_event`;
DROP TABLE IF EXISTS `schedule_event_excute`;
DROP TABLE IF EXISTS `schedule_eventer`;
-- 日程表
CREATE TABLE IF NOT EXISTS `calender` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL COMMENT '邮箱ID',
  `name` varchar(20) NOT NULL COMMENT '日程名称',
  `is_default` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否默认日程',
  `created` datetime NOT NULL DEFAULT NOW() COMMENT '创建时间',
  `updated` datetime NOT NULL DEFAULT NOW() COMMENT '更新时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `mailbox_id` (`mailbox_id`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 日程分享表
CREATE TABLE IF NOT EXISTS `calender_share` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `calender_id` int(11) NOT NULL COMMENT '日程ID',
  `target_id` int(11) NOT NULL COMMENT '被共享邮箱',
  `permmisson` tinyint(1) NOT NULL DEFAULT '1' COMMENT '权限',
  -- 1： 查看 2： 查看编辑
  `is_show` tinyint(1) NOT NULL DEFAULT '1' COMMENT '是否显示',
  `created` datetime NOT NULL DEFAULT NOW() COMMENT '创建时间',
  `updated` datetime NOT NULL DEFAULT NOW() COMMENT '更新时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `calender_id` (`calender_id`,`target_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------
-- 日程事件表
CREATE TABLE IF NOT EXISTS `calender_event` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL COMMENT '邮箱ID',
  `calender_id` int(11) NOT NULL COMMENT '日程ID',
  `uuid_string` varchar(200) DEFAULT NULL COMMENT 'UUID',
  `organizer` varchar(250) DEFAULT NULL COMMENT '组织者',
  `title` varchar(200) NOT NULL COMMENT '事件标题',
  `color` varchar(10) DEFAULT NULL COMMENT '日程颜色',
  `location` varchar(200) DEFAULT NULL COMMENT '事件发生地点',
  `description` text COMMENT '事件描述',
  `is_allday` tinyint(1) NOT NULL DEFAULT '1' COMMENT '是否全天事件',
  `dtstart` datetime NOT NULL COMMENT '开始时间',
  `dtend` datetime NOT NULL COMMENT '结束时间',
  `seconds` int(11) NOT NULL DEFAULT '0' COMMENT '开始结束日期差(单位秒)',
  `is_cycle` tinyint(1) NOT NULL DEFAULT '0' COMMENT '周期事件',
  `rrule` longtext COMMENT '重复事件规则表达式',
  `exdate` longtext COMMENT '被排除的日期',
  `is_remind` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否提醒',
  `remind_before` int(11) NOT NULL DEFAULT '10' COMMENT '提前多久提醒',
  `remind_unit` int(11) NOT NULL DEFAULT '60' COMMENT '提醒单位：分钟、小时、日、周',
  -- 60分钟、3600小时、86400天、604800周
  `created` datetime NOT NULL DEFAULT NOW() COMMENT '创建时间',
  `updated` datetime NOT NULL DEFAULT NOW() COMMENT '更新时间',
  PRIMARY KEY (`id`),
  KEY `mailbox_id` (`mailbox_id`),
  KEY `calender_id` (`calender_id`),
  KEY `uuid_string` (`uuid_string`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `calender_event_sequence` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `event_id` int(11) NOT NULL COMMENT '事件ID',
  `dtstart` datetime NOT NULL COMMENT '开始时间',
  `dtend` datetime NOT NULL COMMENT '结束时间',
  `is_remind` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否提醒',
  `is_work` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否已发送邮件',
  `startstamp` bigint(15) NOT NULL DEFAULT '0' COMMENT '开始时间戳',
  `workstamp` bigint(15) NOT NULL DEFAULT '0' COMMENT '发送时间戳',
  `is_single` tinyint(1) NOT NULL DEFAULT '0' COMMENT '单独作为序列处理',
  `recurrence_id` date DEFAULT NULL COMMENT '序列时间',
  `is_allday` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否已发送邮件',
  `title` varchar(200) DEFAULT NULL COMMENT '事件标题',
  `color` varchar(10) DEFAULT NULL COMMENT '日程颜色',
  `location` varchar(200) DEFAULT NULL COMMENT '事件发生地点',
  `description` text COMMENT '事件描述',
  `remind_before` int(11) NOT NULL DEFAULT '10' COMMENT '提前多久提醒',
  `remind_unit` int(11) NOT NULL DEFAULT '60' COMMENT '提醒单位：分钟、小时、日、周', -- 60分钟、3600小时、86400天、604800周
  `created` datetime NOT NULL DEFAULT NOW() COMMENT '创建时间',
  `updated` datetime NOT NULL DEFAULT NOW() COMMENT '更新时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `event_id` (`event_id`,`dtstart`,`dtend`),
  KEY `workstamp` (`workstamp`),
  KEY `recurrence_id` (`event_id`,`recurrence_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `calender_event_sequence` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `event_id` int(11) NOT NULL COMMENT '事件ID',
  `dtstart` datetime NOT NULL COMMENT '开始时间',
  `dtend` datetime NOT NULL COMMENT '结束时间',
  `is_remind` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否提醒',
  `is_work` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否已发送邮件',
  `startstamp` bigint(15) NOT NULL DEFAULT '0' COMMENT '开始时间戳',
  `workstamp` bigint(15) NOT NULL DEFAULT '0' COMMENT '发送时间戳',

  `is_single` tinyint(1) NOT NULL DEFAULT '0' COMMENT '单独作为序列处理',
  `recurrence_id` datetime NULL DEFAULT NULL COMMENT '序列时间',
  `is_allday` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否已发送邮件',
  `title` varchar(200) DEFAULT NULL COMMENT '事件标题',
  `color` varchar(10) DEFAULT NULL COMMENT '日程颜色',
  `location` varchar(200) DEFAULT NULL COMMENT '事件发生地点',
  `description` text COMMENT '事件描述',
  `remind_before` int(11) NOT NULL DEFAULT '10' COMMENT '提前多久提醒',
  `remind_unit` int(11) NOT NULL DEFAULT '60' COMMENT '提醒单位：分钟、小时、日、周',
  `created` datetime NOT NULL DEFAULT NOW() COMMENT '创建时间',
  `updated` datetime NOT NULL DEFAULT NOW() COMMENT '更新时间',

  PRIMARY KEY (`id`),
  KEY `workstamp` (`workstamp`),
  KEY `recurrence_id` (`event_id`, `recurrence_id`),
  UNIQUE KEY `event_id` (`event_id`,`dtstart`,`dtend`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 日程事件参与者表
CREATE TABLE IF NOT EXISTS `calender_eventer` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `event_id` int(11) NOT NULL COMMENT '时间ID',
  `email` varchar(200) NOT NULL COMMENT '日程参加邮箱',
  `status` varchar(8) NOT NULL DEFAULT 'start' COMMENT '状态',
  -- 状态：start起始状态、pass接受、wait待定、reject拒绝、delete已删除、cancel已取消
  PRIMARY KEY (`id`),
  UNIQUE KEY `event_id` (`event_id`,`email`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 日程单个序列事件参与者表
CREATE TABLE IF NOT EXISTS `calender_sequence_eventer` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sequence_id` int(11) NOT NULL COMMENT '时间ID',
  `email` varchar(200) NOT NULL COMMENT '日程参加邮箱',
  `status` varchar(8) NOT NULL DEFAULT 'start' COMMENT '状态',
  -- 状态：start起始状态、pass接受、wait待定、reject拒绝、delete已删除、cancel已取消
  PRIMARY KEY (`id`),
  UNIQUE KEY `event_id` (`sequence_id`,`email`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- 2019-02-28 新版本日历同步表 end

-- 2019-03-06 补充一些旧表
CREATE TABLE IF NOT EXISTS `ext_secret_mail` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `secret_grade` enum('0','1','2') NOT NULL DEFAULT '0',
  `mailbox_id` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `wx_config` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `token` varchar(200) CHARACTER SET gbk NOT NULL,
  `appid` varchar(50) CHARACTER SET gbk NOT NULL,
  `appsecret` varchar(200) NOT NULL DEFAULT '0',
  `access_token` mediumtext CHARACTER SET gbk NOT NULL,
  `dateline` int(10) unsigned NOT NULL,
  `jsapi_ticket` mediumtext CHARACTER SET gbk,
  `jsapiline` int(11) unsigned DEFAULT NULL,
  `name` varchar(200) NOT NULL DEFAULT '--',
  `agentid` varchar(50) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

 CREATE TABLE IF NOT EXISTS `widget_cogroup_member` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `groupno` int(11) NOT NULL DEFAULT '0',
  `mobile` varchar(20) DEFAULT NULL,
  `oauid` int(11) NOT NULL DEFAULT '0',
  `oaname` varchar(35) DEFAULT NULL,
  `mailbox_id` int(11) NOT NULL DEFAULT '0',
  `isadmin` enum('-1','1') NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_unique` (`groupno`,`mailbox_id`),
  KEY `mobile` (`mobile`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- 2019-03-06 补充一些旧表 end

-- 2019-03-25 2.3.1 删除老版本投递状态表
DROP TABLE IF EXISTS ext_mail_deliver_status;
-- 2019-03-25 2.3.1 删除搜索相关表，这些表在2.2.48添加
DROP TABLE IF EXISTS `ext_search_result`;
DROP TABLE IF EXISTS `ext_search_data`;
-- 2.3.1 删除搜索相关表 end

-- 2019-04-18 2.3.1 文件共享表
CREATE TABLE IF NOT EXISTS `wm_netdisk_share` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ucode` varchar(50) NOT NULL COMMENT '链接唯一码',
  `code` varchar(10) DEFAULT NULL COMMENT '提取码',
  `object_id` int(11) NOT NULL DEFAULT '0'  COMMENT '文件关联ID',
  `object_type` varchar(6) NOT NULL DEFAULT 'folder' COMMENT '文件类型',
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `ucode` (`ucode`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='个人文件共享';
-- 2019-04-18 2.3.1 文件共享表 end


-- 2.3.2 2019-04-28
-- 旗帜与标签记录表
DROP TABLE IF EXISTS `ext_email_flag`;
CREATE TABLE IF NOT EXISTS `core_mail_tag` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL,
  `name` varchar(20) NOT NULL,
  `color` varchar(20) NOT NULL default '#D50000',
  `tagname` varchar(20) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `mailbox_id` (`mailbox_id`,`name`),
  UNIQUE KEY `mailbox_id2` (`mailbox_id`,`tagname`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- 2.3.2 2019-04-28 end

-- 2.3.3 2019-05-27
-- 旗帜与标签记录表
CREATE TABLE IF NOT EXISTS `core_mail_remark` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL,
  `remark` text,
  `flag` varchar(20) NOT NULL default '0',
  PRIMARY KEY (`id`),
  KEY `mailbox_id` (`mailbox_id`, `flag`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- 2.3.3 2019-05-27 end

-- 2.3.6 2019-07-12
-- 补充老版本缺失的表
CREATE TABLE IF NOT EXISTS `wx_user_switch` (
  `mailbox_id` int(11) NOT NULL,
  `new_mail_sms` tinyint(2) NOT NULL DEFAULT '0' COMMENT '短信新邮件通知',
  `new_mail_wx` tinyint(2) NOT NULL DEFAULT '0' COMMENT '微信新邮件通知',
  `change_pwd_sms` tinyint(2) NOT NULL DEFAULT '0' COMMENT '修改密码短信通知',
  `change_pwd_wx` tinyint(2) NOT NULL DEFAULT '0' COMMENT '修改密码微信通知',
  `capacity_sms` tinyint(2) NOT NULL DEFAULT '0' COMMENT '容量提醒短信',
  `capacity_wx` tinyint(2) NOT NULL DEFAULT '0' COMMENT '容量提醒微信',
  `reset_pwd_sms` tinyint(2) NOT NULL DEFAULT '0' COMMENT '密码找回提醒',
  `reset_pwd_wx` tinyint(2) NOT NULL DEFAULT '0' COMMENT '密码找回提醒',
  `update_time` int(11) NOT NULL,
  PRIMARY KEY (`mailbox_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `wx_user` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `openid` varchar(128) NOT NULL,
  `unionid` varchar(255) NOT NULL,
  `nickname` varchar(300) NOT NULL,
  `img` varchar(700) NOT NULL COMMENT '头像',
  `update_time` int(11) NOT NULL COMMENT '登录修改时间',
  `add_time` int(11) NOT NULL COMMENT '创建时间',
  `subscribe` tinyint(2) NOT NULL DEFAULT '0' COMMENT '是否关注公众号',
  `subscribe_time` int(11) NOT NULL DEFAULT '0' COMMENT '关注时间',
  `city` varchar(80) NOT NULL DEFAULT '' COMMENT '城市',
  `province` varchar(100) NOT NULL DEFAULT '' COMMENT '省',
  `remark` varchar(2000) NOT NULL DEFAULT '' COMMENT '备注',
  `UserId` varchar(100) NOT NULL DEFAULT '0' COMMENT 'userid',
  `DeviceId` varchar(100) NOT NULL DEFAULT '0' COMMENT '企业号设备',
  `expires_in` int(4) NOT NULL DEFAULT '0' COMMENT '企业号用户票据有效时间',
  `user_ticket` varchar(200) NOT NULL DEFAULT '0' COMMENT '企业号用户票据',
  `department` varchar(20) NOT NULL DEFAULT '0' COMMENT '企业号用户部门',
  `position` varchar(50) NOT NULL DEFAULT '0' COMMENT '企业号用户职位',
  `mobile` varchar(20) NOT NULL DEFAULT '0' COMMENT '企业号用户手机号',
  `gender` int(2) NOT NULL DEFAULT '0' COMMENT '企业号用户性别',
  `email` varchar(50) NOT NULL DEFAULT '0' COMMENT '企业号email',
  PRIMARY KEY (`id`),
  UNIQUE KEY `openid_index` (`openid`,`UserId`,`DeviceId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `wx_msg` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `unionid` varchar(200) NOT NULL,
  `openid` varchar(150) NOT NULL COMMENT '微信openid',
  `temp_id` varchar(150) NOT NULL COMMENT '微信模板wx_template的temp_id',
  `data` varchar(1000) NOT NULL COMMENT '发送内容',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT '微信消息发送成功1失败0',
  `url` varchar(300) NOT NULL COMMENT '微信消息详情返回url',
  `update_time` int(11) NOT NULL DEFAULT '0',
  `add_time` int(11) NOT NULL COMMENT '发送时间',
  `message` varchar(300) DEFAULT 'fail' COMMENT '错误详情',
  `ip` varchar(80) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

 CREATE TABLE IF NOT EXISTS `wx_template` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键',
  `temp_id` varchar(200) NOT NULL COMMENT '微信模板id',
  `type` int(4) NOT NULL DEFAULT '2' COMMENT '2umail 1客户自己的模板',
  `name` varchar(200) NOT NULL COMMENT '模板名称',
  `code` varchar(30) NOT NULL COMMENT '模板标识',
  PRIMARY KEY (`id`),
  UNIQUE KEY `code_type` (`type`,`code`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `wx_api_log` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `way` varchar(30) NOT NULL DEFAULT '0' COMMENT '方法',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT '状态',
  `message` varchar(2500) NOT NULL DEFAULT '0' COMMENT '报错信息',
  `add_time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  `data` varchar(2000) NOT NULL DEFAULT '0' COMMENT '数据json',
  `clinet_ip` varchar(50) NOT NULL DEFAULT '0' COMMENT '调用人的ip',
  `server_ip` varchar(50) NOT NULL DEFAULT '0' COMMENT '服务器ip',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

 CREATE TABLE IF NOT EXISTS `wx_sms_code` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `phone` varchar(25) NOT NULL COMMENT '手机号',
  `code` varchar(10) NOT NULL COMMENT '验证码',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT '发送状态',
  `type` int(4) NOT NULL DEFAULT '1' COMMENT '发送类型',
  `add_time` int(11) NOT NULL COMMENT '发送时间',
  `update_time` int(11) NOT NULL COMMENT '验证时间',
  `ip` varchar(50) NOT NULL COMMENT '发送者ip',
  `ext` varchar(50) NOT NULL DEFAULT '-' COMMENT '备注',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `ext_password_review` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `mailbox_id` int(11) NOT NULL,
  `username` varchar(200) NOT NULL COMMENT '操作的管理员ID',
  `admin` varchar(200) NOT NULL COMMENT '操作的管理员ID',
  `new_password` varchar(200) NOT NULL COMMENT '新密码',
  `modify_time` datetime DEFAULT NULL COMMENT '修改时间',
  `status` varchar(10) DEFAULT 'wait' COMMENT 'wait:等待,permit:批准,reject:拒绝',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- 2.3.6 2019-07-12 end

-- 2.3.17 2020-05-22
-- 补充新版本缺失的表
create table IF NOT EXISTS `wx_template_field` (
	`id` int auto_increment comment '主键' primary key,
	`field_name` varchar(100) not null comment '模板字段名称',
	`field_val` varchar(200) not null comment '模板内容',
	`template_id` varchar(200) not null comment '模板主键',
 	constraint `index` unique (field_name, template_id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
-- 2.3.17 2020-05-22 end
