#!/bin/bash
systemctl stop postfix
systemctl disable postfix
if [[ -z $(which docker) ]]; then 
  echo "install docker"; 
  #yum update -y
  yum install -y yum-utils device-mapper-persistent-data lvm2
  yum-config-manager --add-repo http://mirrors.aliyun.com/docker-ce/linux/centos/docker-ce.repo
  yum install -y docker-ce
fi

if [[ -z $(which git) ]]; then 
  echo "install docker"; 
  yum install -y git
fi

echo '{ "registry-mirrors": ["https://6c0a3n0p.mirror.aliyuncs.com"]}' > /etc/docker/daemon.json

systemctl enable docker.service
systemctl stop docker.service
sleep 2
systemctl start docker.service


if [ ! -f /usr/local/bin/docker-compose ]; then
    /usr/local/u-mail/app/sbin/confbuilder webvue
    curl -L http://update.comingchina.com:8080/docker-compose > /usr/local/bin/docker-compose
    chmod +x /usr/local/bin/docker-compose
    docker-compose -v
fi 

if [ ! -d /usr/local/u-mail ]; then
   cd /usr/local/
   git clone https://code.aliyun.com/umail/u-mail.git
fi

cd /usr/local/u-mail
git pull
/bin/bash "/usr/local/u-mail/generate_config.sh"
docker-compose up -d

